#ifndef HEPVis_SoGui_h
#define HEPVis_SoGui_h

#include <HEPVis/SbBasic.h>

#ifdef HEPVisWin
#include <Inventor/Win/SoWin.h>
#include <Inventor/Win/viewers/SoWinExaminerViewer.h>
#define SoGui               SoWin
#define SoGuiComponent      SoWinComponent
#define SoGuiWidget         HWND
#define SoGuiEvent          MSG
#define SoGuiExaminerViewer SoWinExaminerViewer
#define SoGuiPainterViewer  SoWinPainterViewer
#if !defined(__COIN_SOWIN__) && !defined(SoFreePackage)
#define main HEPVis_main
#endif
#endif

#ifdef HEPVisXt
#include <Inventor/Xt/SoXt.h>
#include <Inventor/Xt/viewers/SoXtExaminerViewer.h>
#define SoGui               SoXt
#define SoGuiComponent      SoXtComponent
#define SoGuiWidget         Widget
#define SoGuiEvent          XAnyEvent
#define SoGuiExaminerViewer SoXtExaminerViewer
#define SoGuiPainterViewer  SoXtPainterViewer
#endif

#ifdef HEPVisQt
#include <Inventor/Qt/SoQt.h>
#include <Inventor/Qt/viewers/SoQtExaminerViewer.h>
#define SoGui               SoQt
#define SoGuiComponent      SoQtComponent
#define SoGuiWidget         QWidget*
#define SoGuiEvent          QEvent
#define SoGuiExaminerViewer SoQtExaminerViewer
#define SoGuiPainterViewer  SoQtPainterViewer
#endif

#ifdef HEPVisGtk
#include <Inventor/Gtk/SoGtk.h>
#include <Inventor/Gtk/viewers/SoGtkExaminerViewer.h>
#define SoGui               SoGtk
#define SoGuiComponent      SoGtkComponent
#define SoGuiWidget         GtkWidget*
#define SoGuiEvent          GdkEvent
#define SoGuiExaminerViewer SoGtkExaminerViewer
#define SoGuiPainterViewer  SoGtkPainterViewer
#endif

#endif
