#ifndef HEPVis_SbFile_h
#define HEPVis_SbFile_h

#include <Inventor/SbBasic.h>
#include <Inventor/SbString.h>

#ifdef WIN32
#include <windows.h>
#endif

class SbStringList;

class SbFile {
public:
  const char* getWorkingDirectory();
  void* openDirectory(const char*);
  const char* getDirectoryEntry(void*);
  void closeDirectory(void*);
  SbBool isDirectory(const char*);
  SbStringList* getDirectoryFiles(const char*);
  SbStringList* getDirectoryDirectories(const char*);
  void dumpDirectory(const char*);
  SbBool tmpname(SbString&,const SbString& = "",const SbString& = "tmp",const SbString& = "");
private:
#ifdef WIN32
  WIN32_FIND_DATA fFindFileData;
#endif
};


#endif

