#ifndef HEPVis_SbProjector_h
#define HEPVis_SbProjector_h 

#include <Inventor/SbString.h>
#include <Inventor/SbLinear.h>

#include <HEPVis/SbStyles.h>

/*!
 * class SbProjector
 *
 * To handle special (non-linear) projections (rz, phiz, etc...)
*/
namespace HEPVis {

class SbProjector {
public:
  SbProjector(SbProjectionType);
  SbProjector(const SbProjector&);
  virtual ~SbProjector();
  SbBool project(int,SbVec3f*) const;
  SbProjectionType type() const;
protected:
  SbBool projectRZ(int,SbVec3f*) const;
  SbBool projectPHIZ(int,SbVec3f*) const;
  SbBool projectZR(int,SbVec3f*) const;
  SbBool projectZPHI(int,SbVec3f*) const;
private:
  SbProjectionType fType;
};

}

#endif
