//  27/03/2004 : G.Barrand : creation.

#ifndef HEPVis_SoStyleCache_h
#define HEPVis_SoStyleCache_h

#include <Inventor/nodes/SoGroup.h>

#include <HEPVis/SbStyles.h>

class SoMaterial;
class SoHighlightMaterial;
class SoDrawStyle;
class SoLightModel;
class SoResetTransform;
class SbColor;
 
class SoStyleCache : public SoGroup {
public:
  SoStyleCache();
protected:
  virtual ~SoStyleCache();
public:
  SoMaterial* getMaterial(const SbColor&,float = 0); 
  SoMaterial* getMaterial(float,float,float,float = 0); 
  SoHighlightMaterial* getHighlightMaterial(const SbColor&,const SbColor&,float = 0); 
  SoHighlightMaterial* getHighlightMaterial(float,float,float,float,float,float,float = 0); 
  SoDrawStyle* getLineStyle(SbLinePattern = SbLinePattern_solid,float = 0); 
  SoDrawStyle* getFilled(); 
  SoLightModel* getLightModelPhong(); 
  SoLightModel* getLightModelBaseColor(); 
  SoResetTransform* getResetTransform();
private:
  SoGroup* fMaterials;
  SoGroup* fHighlightMaterials;
  SoGroup* fLineStyles;
  SoGroup* fLightModels;
  SoResetTransform* fResetTransform;
};

#endif
