#ifndef Lab_Annotation_h
#define Lab_Annotation_h

#include <AIDA/IAnnotation.h>

#include <list>

namespace Lab {

class Item {
public:
  std::string fKey;
  std::string fValue;
  bool fSticky;
};

class Annotation : public virtual AIDA::IAnnotation {
public: //AIDA/IAnnotation
  virtual bool addItem(const std::string&,const std::string&,bool = true);
  virtual bool removeItem(const std::string&);
  virtual std::string value(const std::string&) const;
  virtual bool visibility(const std::string&) const;
  virtual void setValue(const std::string&,const std::string&);
  virtual void setSticky(const std::string&,bool);
  virtual int size() const;
  virtual std::string key(int) const;
  virtual std::string value(int) const;
  virtual void reset();
public:
  Annotation();
  Annotation(const Annotation&);
  virtual ~Annotation();
  Annotation& operator=(const Annotation&);
  virtual bool sticky(int) const; //FIXME : should be in AIDA::IAnnotation.
  void clear();
private:
  Item* getItem(const std::string&) const;
private:
  std::list<Item*> fItems;
};

}

#endif
