#ifndef Lab_AsciiTree_h
#define Lab_AsciiTree_h

// Inheritance :
#include <Lab/Core/MemoryTree.h>

namespace Lib {
  class Out;
}

namespace AIDA {
  class ITuple;
}

namespace Lab {

class AsciiTree : public MemoryTree {
public: //IManager
  virtual void* cast(const std::string&) const;
public: //AIDA/ITree
  virtual bool commit();
  virtual std::string storeName() const;
public:
  AsciiTree(ISession&,const std::string&,const std::string&,bool,bool,const std::string&);
  virtual ~AsciiTree();
  void writeTuple(Lib::Out&,
                  const std::string&,const std::string&,
                  AIDA::ITuple&);
  void setHippoStyle(bool);
  bool createNew() const;
private:
  std::string fStoreName;
  bool fReadOnly;
  bool fCreateNew;
  bool fHippoStyle;
};

}

#endif
