#ifndef Lab_BaseFolder_h
#define Lab_BaseFolder_h

// Inheritance :
#include <Lab/Interfaces/IFolder.h>

#include <string>
#include <list>

class IPrinter;

namespace Lab {

class BaseTree;

class BaseFolder : public virtual IFolder {
public: //IFolder
  virtual IFolder* parent() const;
  virtual const std::string& name() const;
  virtual void setName(const std::string&);
  virtual AIDA::IManagedObject* findInTree(const std::string&,IFolder*&) const;
  virtual AIDA::IManagedObject* findObject(const std::string&) const;
  virtual bool isValid(const AIDA::IManagedObject*) const;
  virtual IFolder* findFolder(const std::string&) const;
  virtual void ls() const;
  virtual std::string path() const;
  virtual bool visit(IFolderVisitor&) const;
  virtual void setParent(IFolder*);
  virtual void setLinkingFolder(IFolder*);
  virtual IFolder* linkingFolder() const;
  virtual std::string linkingPath() const;

  virtual BaseTree& tree() const;
public:
  BaseFolder(IPrinter&,IFolder*,const std::string&,BaseTree&);
  virtual ~BaseFolder();
  std::string hierarchy(const std::string& = "") const; 
protected:
  IPrinter& fPrinter;
  IFolder* fParent;
  std::string fName;
  BaseTree& fTree;
  IFolder* fLinkingFolder;
};

}

#endif
