#ifndef Lab_BaseObject_h
#define Lab_BaseObject_h

// Inheritance :
#include <AIDA/IManagedObject.h>

class IPrinter;
namespace Lib {
  class IRelationManager;
}
class IFolder;

namespace Lab {

class BaseObject : public virtual AIDA::IManagedObject {
public: //AIDA/IManagedObject
  virtual std::string name() const;
public:
  virtual BaseObject* copy(const std::string&) const = 0;
public:
  virtual IPrinter& printer() const;
  //virtual const std::string& manager() const;
  //virtual bool setManager(const std::string&);

  virtual void setName(const std::string&);
  virtual void setFolder(IFolder*);
  virtual void emitUpdate();
protected:
  BaseObject(IPrinter&,const std::string&);
public:
  virtual ~BaseObject();
  void setRelationManager(Lib::IRelationManager*);//FIXME
private:
  IPrinter& fPrinter;
  std::string fName;
  IFolder* fFolder;
  Lib::IRelationManager* fRelationManager;
};

}

#endif
