#ifndef Lab_BaseTree_h
#define Lab_BaseTree_h

// Inheritance :
#include <AIDA/ITree.h>
#include <Lib/Interfaces/IManager.h>

#include <list>

class ISession;
class IPrinter;

namespace Lib {
  class IRelationManager;
} 

namespace Lab {

class BaseObject;

class BaseTree 
:public virtual AIDA::ITree
,public virtual IManager {
public: //IManager
  virtual const std::string& name() const;
  virtual void* cast(const std::string&) const;
public:
  BaseTree(ISession&,const std::string&);
  virtual ~BaseTree();
  virtual void setVerboseLevel(int);
  int verboseLevel() const;
public:
  virtual bool addObject(BaseObject*,const std::string&) = 0;
  virtual bool isObjectValid(const AIDA::IManagedObject*) const = 0;
  virtual std::string hierarchy() const = 0; 
public:
  virtual void emitUpdate();
  virtual bool manageObject(BaseObject*,const std::string&);
  virtual IPrinter& printer() const;
  virtual ISession& session() const;
private:
  ISession& fSession;
  std::string fName;
  int fVerboseLevel;
protected:
  Lib::IRelationManager* fRelationManager;
};

}

#endif
