#ifndef Lab_ChainedTuple_h
#define Lab_ChainedTuple_h

// Inheritance :
#include <Lab/Core/BaseTuple.h>
#include <AIDA/ITupleEntry.h> //FIXME

namespace Lab {

class ChainedTuple 
:public BaseTuple
,public virtual AIDA::ITupleEntry  //FIXME
{
public: //AIDA/ITuple
  //fill :
  virtual bool fill(int,double);
  virtual bool fill(int,float);
  virtual bool fill(int,int);
  virtual bool fill(int,short);
  virtual bool fill(int,long);
  virtual bool fill(int,char);
  virtual bool fill(int,bool);
  virtual bool fill(int,const std::string&);
  virtual bool fill(int,const AIDA::ITupleEntry&);
  virtual bool fill(const std::vector<double>&);
  virtual bool fill(const std::vector<float>&);
  //get :
  virtual double getDouble(int) const;
  virtual float getFloat(int) const;
  virtual int getInt(int) const;
  virtual short getShort(int) const;
  virtual long getLong(int) const;
  virtual char getChar(int) const;
  virtual bool getBoolean(int) const;
  virtual std::string getString(int) const;
  virtual const AIDA::ITupleEntry* getObject(int) const;
  //else :
  virtual int rows() const;
  virtual bool addRow();
  virtual void* cast(const std::string&) const;
  virtual const AIDA::ITuple* getTuple(int) const;
  virtual AIDA::ITuple* getTuple(int);
  //Override BaseTuple :
  virtual int findColumn(const std::string&) const;
  virtual int columns() const;
  virtual std::string columnName(int) const;
  virtual std::vector<std::string>  columnNames() const;
  virtual std::string columnType(int) const;
  virtual std::vector<std::string>  columnTypes() const;
  virtual void resetRow();
  virtual void reset();
  virtual double columnMin(int) const;
  virtual double columnMax(int) const;
  virtual double columnMean(int) const;
  virtual double columnRms(int) const;
public: //Lab::BaseObject
  virtual BaseObject* copy(const std::string&) const;
public: //Lab::BaseTuple
  virtual unsigned char getByte(int) const;
  virtual bool fill33(int,unsigned char);
public:
  ChainedTuple(IPrinter&,
               const std::string&,
               const std::string&,
               const std::vector<AIDA::ITuple*>&);
  ChainedTuple(const std::string&,const ChainedTuple&);
  virtual ~ChainedTuple();
private:
  bool findRow(int,AIDA::ITuple*&,int&) const;
private:
  std::vector<AIDA::ITuple*> fTuples;
};

}

#endif


