#ifndef Lab_DataPoint_h
#define Lab_DataPoint_h

#include <AIDA/IDataPoint.h>

#include <vector>

#include <Lab/Core/Measurement.h>

namespace Lab {

class DataPoint : public virtual AIDA::IDataPoint {
public: //AIDA/IDataPoint
  virtual int dimension() const;
  virtual AIDA::IMeasurement* coordinate(int coord);
  virtual const AIDA::IMeasurement* coordinate(int coord) const;
public:
  DataPoint(int);
  DataPoint(const DataPoint&);
  DataPoint(const AIDA::IDataPoint&);
  virtual ~DataPoint();
  DataPoint& operator=(const DataPoint&);
private:
  void initialize(const AIDA::IDataPoint&);
private:
  int fDimension;
  std::vector<Measurement> fMeasurements;
};

}

#endif
