#ifndef Lab_DataPointSetFactory_h
#define Lab_DataPointSetFactory_h

// Inheritance :
#include <Lab/Core/BaseFactory.h>
#include <AIDA/IDataPointSetFactory.h>

class IPrinter;

namespace Lab {

class DataPointSetFactory 
:public BaseFactory
,public virtual AIDA::IDataPointSetFactory 
{
public: //AIDA/AIDA::IDataPointSetFactory
  virtual AIDA::IDataPointSet* create(const std::string&,const std::string&,
                                      int);
  virtual AIDA::IDataPointSet* create(const std::string&,
                                      int);
  virtual AIDA::IDataPointSet* createCopy(const std::string&,
                                          const AIDA::IDataPointSet&);
  virtual bool destroy(AIDA::IDataPointSet*);
  virtual AIDA::IDataPointSet* create(const std::string&,
                                      const AIDA::IHistogram1D&,
                                      const std::string&);
  virtual AIDA::IDataPointSet* create(const std::string&,
                                      const AIDA::IHistogram2D&,
                                      const std::string&);
  virtual AIDA::IDataPointSet* create(const std::string&,
                                      const AIDA::IHistogram3D&,
                                      const std::string&);
  virtual AIDA::IDataPointSet* create(const std::string&,
                                      const AIDA::ICloud1D&,
                                      const std::string&);
  virtual AIDA::IDataPointSet* create(const std::string&,
                                      const AIDA::ICloud2D&,
                                      const std::string&);
  virtual AIDA::IDataPointSet* create(const std::string&,
                                      const AIDA::ICloud3D&,
                                      const std::string&);
  virtual AIDA::IDataPointSet* create(const std::string&,
                                      const AIDA::IProfile1D&,
                                      const std::string&);
  virtual AIDA::IDataPointSet* create(const std::string&,
                                      const AIDA::IProfile2D&,
                                      const std::string&);
  virtual AIDA::IDataPointSet* add(const std::string&,
                                   const AIDA::IDataPointSet&,
                                   const AIDA::IDataPointSet&);
  virtual AIDA::IDataPointSet* subtract(const std::string&,
                                        const AIDA::IDataPointSet&,
                                        const AIDA::IDataPointSet&);
  virtual AIDA::IDataPointSet* multiply(const std::string&,
                                        const AIDA::IDataPointSet&,
                                        const AIDA::IDataPointSet&);
  virtual AIDA::IDataPointSet* divide(const std::string&,
                                      const AIDA::IDataPointSet&,
                                      const AIDA::IDataPointSet&);
  virtual AIDA::IDataPointSet* weightedMean(const std::string&,
                                      const AIDA::IDataPointSet&,
                                      const AIDA::IDataPointSet&);

  virtual AIDA::IDataPointSet* createX(const std::string&,const std::string&, 
                                       const std::vector<double>&,
                                       const std::vector<double>&);
  virtual AIDA::IDataPointSet* createX(const std::string&,const std::string&, 
                                       const std::vector<double>&,
                                       const std::vector<double>&,
                                       const std::vector<double>&);
  virtual AIDA::IDataPointSet* createX(const std::string&,
                                       const std::vector<double>&,
                                       const std::vector<double>&);
  virtual AIDA::IDataPointSet* createX(const std::string&,
                                       const std::vector<double>&,
                                       const std::vector<double>&,
                                       const std::vector<double>&);

  virtual AIDA::IDataPointSet* createY(const std::string&,const std::string&, 
                                       const std::vector<double>&,
                                       const std::vector<double>&);
  virtual AIDA::IDataPointSet* createY(const std::string&,const std::string&, 
                                       const std::vector<double>&,
                                       const std::vector<double>&,
                                       const std::vector<double>&);
  virtual AIDA::IDataPointSet* createY(const std::string&,
                                       const std::vector<double>&,
                                       const std::vector<double>&);
  virtual AIDA::IDataPointSet* createY(const std::string&,
                                       const std::vector<double>&,
                                       const std::vector<double>&,
                                       const std::vector<double>&);

  virtual AIDA::IDataPointSet* createXY(const std::string&,const std::string&, 
                                        const std::vector<double>&,
                                        const std::vector<double>&, 
                                        const std::vector<double>&,
                                        const std::vector<double>&);
  virtual AIDA::IDataPointSet* createXY(const std::string&,const std::string&, 
                                        const std::vector<double>&,
                                        const std::vector<double>&, 
                                        const std::vector<double>&,
                                        const std::vector<double>&,
                                        const std::vector<double>&,
                                        const std::vector<double>&);
  virtual AIDA::IDataPointSet* createXY(const std::string&,
                                        const std::vector<double>&,
                                        const std::vector<double>&, 
                                        const std::vector<double>&,
                                        const std::vector<double>&);
  virtual AIDA::IDataPointSet* createXY(const std::string&,
                                        const std::vector<double>&,
                                        const std::vector<double>&, 
                                        const std::vector<double>&,
                                        const std::vector<double>&,
                                        const std::vector<double>&,
                                        const std::vector<double>&);

  virtual AIDA::IDataPointSet* createXYZ(const std::string&,const std::string&, 
                                        const std::vector<double>&,
                                        const std::vector<double>&, 
                                        const std::vector<double>&,
                                        const std::vector<double>&, 
                                        const std::vector<double>&,
                                        const std::vector<double>&);
  virtual AIDA::IDataPointSet* createXYZ(const std::string&,const std::string&, 
                                        const std::vector<double>&,
                                        const std::vector<double>&, 
                                        const std::vector<double>&,
                                        const std::vector<double>&,
                                        const std::vector<double>&, 
                                        const std::vector<double>&,
                                        const std::vector<double>&,
                                        const std::vector<double>&,
                                        const std::vector<double>&);
  virtual AIDA::IDataPointSet* createXYZ(const std::string&,
                                        const std::vector<double>&,
                                        const std::vector<double>&, 
                                        const std::vector<double>&,
                                        const std::vector<double>&, 
                                        const std::vector<double>&,
                                        const std::vector<double>&);
  virtual AIDA::IDataPointSet* createXYZ(const std::string&,
                                        const std::vector<double>&,
                                        const std::vector<double>&, 
                                        const std::vector<double>&,
                                        const std::vector<double>&,
                                        const std::vector<double>&, 
                                        const std::vector<double>&,
                                        const std::vector<double>&,
                                        const std::vector<double>&,
                                        const std::vector<double>&);
public:
  DataPointSetFactory(IPrinter&,AIDA::ITree&);
  virtual ~DataPointSetFactory();
};

}

#endif
