#ifndef Lab_Evaluator_h
#define Lab_Evaluator_h

#include <AIDA/IEvaluator.h>

#include <vector>
#include <string>

namespace Lib {
  class Processor;
}

class IPrinter;

namespace AIDA {
  class ITuple;
}

namespace Lab {

class Evaluator : public virtual AIDA::IEvaluator {
public: //AIDA/IEvaluator
  virtual bool initialize(AIDA::ITuple&);
  virtual double evaluateDouble() const;
  virtual std::string expression() const;
public:
  //virtual const std::string& label() const;
  Evaluator(IPrinter&,const std::string&);
  virtual ~Evaluator();
private:
  IPrinter& fPrinter;
  const AIDA::ITuple* fTuple;
  //std::string fLabel;
  std::string fScript;
  Lib::Processor* fProcessor;
  std::vector<std::string> fNames;
  std::vector<int> fIndices;
};

}

#endif
