#ifndef Lab_Filter_h
#define Lab_Filter_h

#include <AIDA/IFilter.h>

#include <vector>

namespace Lib {
  class Processor;
}

class IPrinter;


namespace AIDA {
  class ITuple;
}

namespace Lab {

class Filter : public virtual AIDA::IFilter {
public: //AIDA/IFilter
  virtual bool initialize(AIDA::ITuple&);
  virtual bool accept() const;
  virtual std::string expression() const;
public:
  //virtual const std::string& label() const;
  Filter(IPrinter&,const std::string&);
  virtual ~Filter();
private:
  IPrinter& fPrinter;
  const AIDA::ITuple* fTuple;
  //std::string fLabel;
  std::string fScript;
  Lib::Processor* fProcessor;
  std::vector<std::string> fNames;
  std::vector<int> fIndices;
};

}

#endif
