#ifndef Lab_FitData_h
#define Lab_FitData_h

// Inheritance :
#include <AIDA/IFitData.h>

#include <Lab/Core/RangeSet.h>

namespace Lab {

class FitData : public virtual AIDA::IFitData {
public: 
  virtual bool create1DConnection(const AIDA::IHistogram1D&);
  virtual bool create1DConnection(const AIDA::ICloud1D&);
  virtual bool create1DConnection(const AIDA::IProfile1D&);
  virtual bool create1DConnection(const AIDA::IDataPointSet&,int,int);
  virtual bool create2DConnection(const AIDA::IHistogram2D&);
  virtual bool create2DConnection(const AIDA::IHistogram2D&,int,int);
  virtual bool create2DConnection(const AIDA::ICloud2D&);
  virtual bool create2DConnection(const AIDA::ICloud2D&,int,int);
  virtual bool create2DConnection(const AIDA::IProfile2D&);
  virtual bool create2DConnection(const AIDA::IProfile2D&,int,int);
  virtual bool create2DConnection(const AIDA::IDataPointSet&,int,int,int);
  virtual bool create3DConnection(const AIDA::IHistogram3D&);
  virtual bool create3DConnection(const AIDA::IHistogram3D&,int,int,int);
  virtual bool create3DConnection(const AIDA::ICloud3D&);
  virtual bool create3DConnection(const AIDA::ICloud3D&,int,int,int);
  virtual bool create3DConnection(const AIDA::IDataPointSet&,int,int,int,int);
  virtual bool createConnection(const AIDA::ITuple&,std::vector<std::string>);
  virtual bool createConnection(const AIDA::ITuple&,std::vector<AIDA::IEvaluator*>&);
  virtual bool createConnection(const AIDA::IDataPointSet&,std::vector<int>,int);
  virtual void reset();
  virtual int dimension() const;
  virtual std::string dataDescription() const;
  virtual AIDA::IRangeSet& range(int) const;
public: 
  FitData();
  virtual ~FitData();
private:
  RangeSet fRangeSet;
};

}

#endif
