#ifndef Lab_FitFactory_h
#define Lab_FitFactory_h

#include <AIDA/IFitFactory.h>

namespace AIDA {
  class IFitData;
  class IFitter;
  class IFunctionFactory;
}

class IPrinter;

namespace Lab {

class FitFactory : public virtual AIDA::IFitFactory {
public: //AIDA/IFitFactory
  virtual AIDA::IFitData* createFitData();
  virtual AIDA::IFitter* createFitter(const std::string&,
                                      const std::string&,const std::string&);
public:
  FitFactory(IPrinter&,AIDA::IFunctionFactory*);
  virtual ~FitFactory();
private:
  IPrinter& fPrinter;
  AIDA::IFunctionFactory* fFunctionFactory;
};

}

#endif
