#ifndef Lab_FitParameterSettings_h
#define Lab_FitParameterSettings_h

#include <AIDA/IFitParameterSettings.h>

namespace Lab {

class FitParameterSettings : public virtual AIDA::IFitParameterSettings {
public: //AIDA::IFitParameterSettings
  virtual std::string name() const;
  virtual double stepSize() const;
  virtual double upperBound() const;
  virtual double lowerBound() const;
  virtual bool isBound() const;
  virtual bool isFixed() const;
  virtual void setStepSize(double);
  virtual void setBounds(double,double);
  virtual void removeBounds();
  virtual void setFixed(bool);
  virtual void setLowerBound(double);
  virtual void setUpperBound(double);
  virtual void reset();
public:
  FitParameterSettings(const std::string&);
  FitParameterSettings(const FitParameterSettings&);
  FitParameterSettings& operator =(const FitParameterSettings&);
  virtual ~FitParameterSettings();
private:
  std::string fName;
  double fStepSize;
  double fLowerBound;
  double fUpperBound;
  bool fFixed;
};

}

#endif
