#ifndef Lab_FitResult_h
#define Lab_FitResult_h

#include <AIDA/IFitResult.h>

namespace AIDA {
  class IFitParameterSettings;
}

namespace Lab {

class FitResult : public virtual AIDA::IFitResult {
public: //AIDA::IFitResult
  virtual bool isValid();
  virtual int fitStatus();
  virtual AIDA::IFunction& fittedFunction();
  virtual double quality();
  virtual int ndf();
  virtual double covMatrixElement(int,int);
  virtual std::string fitMethodName();
  virtual std::string engineName();
  virtual std::string dataDescription();
  virtual std::vector<std::string> constraints();
  virtual AIDA::IFitParameterSettings* fitParameterSettings(const std::string&);
  virtual const std::vector<double>& fittedParameters() const;
  virtual std::vector<std::string> fittedParameterNames() const;
  virtual double fittedParameter(const std::string&);
  virtual const std::vector<double>& errors() const;
  virtual const std::vector<double>& errorsPlus() const;
  virtual const std::vector<double>& errorsMinus() const;
public:
  FitResult(AIDA::IFunction&,const std::vector<double>&,int,double);
  virtual ~FitResult();
private:
  AIDA::IFunction& fFunction;
  std::string fFitMethodName;
  std::string fEngineName;
  std::string fDataDescription;
  std::vector<std::string> fConstraints;
  std::vector<double> fFittedParameters;
  std::vector<std::string> fFittedParameterNames;
  std::vector<double> fErrors;
  std::vector<double> fErrorsPlus;
  std::vector<double> fErrorsMinus;
  double fQuality;
  int fNDF;
};

}

#endif
