#ifndef Lab_Folder_h
#define Lab_Folder_h

// Inheritance :
#include <Lab/Core/BaseFolder.h>

namespace Lab {

class Folder : public BaseFolder {
public: //IFolder
  virtual void* cast(const std::string&) const;
  virtual void add(AIDA::IManagedObject*);
  virtual void remove(AIDA::IManagedObject*);
  virtual void add(IFolder*);
  virtual void remove(IFolder*);
  virtual bool link(IFolder*,const std::string&);
  virtual bool unlink(IFolder*);
  virtual void clear();
  virtual IFolder* mkdir(const std::string&);
  virtual IIterator* objects() const;
  virtual IFolderIterator* folders() const;
public:
  Folder(IPrinter&,IFolder*,const std::string&,BaseTree&);
  virtual ~Folder();
private:
  std::list<IFolder*> fFolders;
  std::list<AIDA::IManagedObject*> fObjects;
};

}

#endif
