#ifndef Lab_FunctionFactory_h
#define Lab_FunctionFactory_h

// Inheritance :
#include <Lab/Core/BaseFactory.h>
#include <AIDA/IFunctionFactory.h>

namespace AIDA {
  class IFunction1D;
  class IFunction2D;
}

class ISession;

namespace Lab {

class FunctionFactory 
:public BaseFactory
,public virtual AIDA::IFunctionFactory 
{
public: //AIDA/IFunctionFactory
  virtual AIDA::IFunction* createFunctionByName(const std::string&,
                                                const std::string&);
  virtual AIDA::IFunction* createFunctionFromScript(const std::string&,
                                                    int,
                                                    const std::string&, 
                                                    const std::string&,
                                                    const std::string&,
                                                    const std::string& = "");
  /*FIXME  virtual AIDA::IFitFunction* createFit(const std::string&,
                                        const std::string&, 
                                        const std::string&, 
                                        const std::string&);
  */
  virtual AIDA::IFunction* cloneFunction(const std::string&,
                                         AIDA::IFunction&);

  virtual AIDA::IFunctionCatalog* catalog();
public:
  FunctionFactory(ISession&,AIDA::ITree&);
  virtual ~FunctionFactory();
private:
  ISession& fSession;
};

}

#endif
