#ifndef Lab_HistogramAction_h
#define Lab_HistogramAction_h

class ISession;

namespace AIDA {
  class IHistogram1D;
  class IHistogram2D;
}

#include <Lib/Interfaces/IAction.h>

namespace Lib { 
  class ITypeManager;
}

namespace Lab {

class HistogramAction : public virtual Lib::IAction {
public: //Lib::IAction
  virtual void* cast(const std::string&) const;
  virtual const std::string& name() const;
  virtual std::string execute(const std::vector<std::string>&);
public:
  HistogramAction(Lib::ITypeManager&,ISession&);
  virtual ~HistogramAction();
  ISession& getSession();
  AIDA::IHistogram1D* getHistogram1D();
  AIDA::IHistogram2D* getHistogram2D();
private:
  Lib::ITypeManager& fTypeManager;
  std::string fName;
  ISession& fSession;
  AIDA::IHistogram1D* fHistogram1D;
  AIDA::IHistogram2D* fHistogram2D;
};

}

#endif



