#ifndef Lab_LinkFolder_h
#define Lab_LinkFolder_h

// Inheritance :
#include <Lab/Core/BaseFolder.h>

namespace Lab {

class LinkFolder : public BaseFolder {
public: //IFolder
  virtual void* cast(const std::string&) const;
  virtual void add(AIDA::IManagedObject*);
  virtual void remove(AIDA::IManagedObject*);
  virtual void add(IFolder*);
  virtual void remove(IFolder*);
  virtual bool link(IFolder*,const std::string&);
  virtual bool unlink(IFolder*);
  virtual void clear();
  virtual IFolder* mkdir(const std::string&);
  virtual IIterator* objects() const;
  virtual IFolderIterator* folders() const;
  virtual bool isSymlink() const;
public:
  LinkFolder(IPrinter&,IFolder*,const std::string&,BaseTree&,IFolder*);
  virtual ~LinkFolder();
  IFolder* linkedFolder() const;
  void setLinkedFolder(IFolder*);
private:
  IFolder* fLinkedFolder;
};

}

#endif
