#ifndef Lab_PlotterFactory_h
#define Lab_PlotterFactory_h

#include <AIDA/IPlotterFactory.h>

#include <vector>

class ISession;
class IUI;

namespace Lab {

class PlotterFactory : public virtual AIDA::IPlotterFactory {
public: //AIDA/IPlotterFactory
  virtual AIDA::IPlotter* create(const std::string&);
  virtual AIDA::IMarkerStyle* createMarkerStyle();
  virtual AIDA::ITextStyle* createTextStyle();
  virtual AIDA::ILineStyle* createLineStyle();
  virtual AIDA::IFillStyle* createFillStyle();
  virtual AIDA::IDataStyle* createDataStyle();
  virtual AIDA::IAxisStyle* createAxisStyle();
  virtual AIDA::ITitleStyle* createTitleStyle();
  virtual AIDA::IPlotterStyle* createPlotterStyle();
public:
  PlotterFactory(ISession&,const std::string&,const std::string&,int,char**);
  virtual ~PlotterFactory();
private:
  AIDA::IPlotter* loadPlotter(const std::string&,const std::string&,
                              const std::string&,const std::string&,
                              const std::string&);
  IUI* loadUI();
private:
  ISession& fSession;
  std::string fImplementation;
  std::string fLibrary;  
  std::vector<std::string> fArgs;  
  int fArgc;
  char** fArgv;
};

}

#endif
