#ifndef Lab_TreeFactory_h
#define Lab_TreeFactory_h

#include <AIDA/ITreeFactory.h>

class ISession;
class IPrinter;

namespace Lab {

class TreeFactory : public virtual AIDA::ITreeFactory {
public: //AIDA/ITreeFactory
  virtual AIDA::ITree* create();
  virtual AIDA::ITree* create(const std::string&,
                              const std::string& = "",
                              bool = false, 
                              bool = false, 
                              const std::string& = "" );
public:
  TreeFactory(ISession&);
  virtual ~TreeFactory();
private:
  AIDA::ITree* loadTree(const std::string&,
                        const std::string&,const std::string&,
                        const std::string&,const std::string&,
                        bool,bool,
                        const std::string&);
private:
  ISession& fSession;
  IPrinter& fPrinter;
};

}

#endif
