#ifndef Lab_TupleFactory_h
#define Lab_TupleFactory_h

#include <AIDA/ITupleFactory.h>

namespace AIDA {
  class ITuple;
  class IFilter;
  class IEvaluator;
}

class ISession;

#include <Lab/Core/BaseFactory.h>

namespace Lab {

class TupleFactory 
:public BaseFactory
,public virtual AIDA::ITupleFactory {
public: //AIDA/ITupleFactory
  virtual AIDA::ITuple* create(const std::string &,
                               const std::string &,
                               const std::vector<std::string>&,
                               const std::vector<std::string>&,
                               const std::string&);
  
  virtual AIDA::ITuple* create(const std::string&,
                               const std::string&,
                               const std::string&,
                               const std::string&);

  virtual AIDA::ITuple* createChained(const std::string&, 
                                      const std::string&,
                                      const std::vector<AIDA::ITuple*>&);
  virtual AIDA::ITuple* createChained(const std::string&,
                                      const std::string&,
                                      const std::vector<std::string>&);
  virtual AIDA::ITuple* createFiltered(const std::string&,
                                       AIDA::ITuple&,AIDA::IFilter&);
  virtual AIDA::ITuple* createFiltered(const std::string&,
                                       AIDA::ITuple&,AIDA::IFilter&,
                                       const std::vector<std::string>&);

  virtual AIDA::IFilter* createFilter(const std::string&);
  virtual AIDA::IFilter* createFilter(const std::string&,int,int = 0);
  virtual AIDA::IEvaluator* createEvaluator(const std::string&);
public:
  virtual AIDA::ITuple* createCopy(const std::string&,const AIDA::ITuple&);
public:
  TupleFactory(ISession&,AIDA::ITree&);
  virtual ~TupleFactory();
private:
  ISession& fSession;
};

}

#endif
