#ifndef Lab_Types_h
#define Lab_Types_h

#include <OnX/Core/BaseType.h>

class ISession;

namespace Lab {

class Bin1D_Type : public Lib::BaseType {
public:
  Bin1D_Type(ISession&);
  virtual ~Bin1D_Type();
public: //Lib::IType
  virtual const std::string& name() const;
  virtual Lib::IIterator* iterator();
  virtual Lib::Variable value(Lib::Identifier,const std::string&,void*);
private:
  ISession& fSession;
  std::string fName;
};

class Bin2D_Type : public Lib::BaseType {
public:
  Bin2D_Type(ISession&);
  virtual ~Bin2D_Type();
public: //Lib::IType
  virtual const std::string& name() const;
  virtual Lib::IIterator* iterator();
  virtual Lib::Variable value(Lib::Identifier,const std::string&,void*);
private:
  ISession& fSession;
  std::string fName;
};

class ManagedObjectType : public OnX::BaseType {
public:
  ManagedObjectType(ISession&);
  virtual ~ManagedObjectType();
public: //Lib::IType
  virtual const std::string& name() const;
  virtual Lib::IIterator* iterator();
  virtual Lib::Variable value(Lib::Identifier,const std::string&,void*);
public: //OnX::IType
  virtual void visualize(Lib::Identifier,void*);
private:
  ISession& fSession;
  std::string fName;
};

class FunctionType : public OnX::BaseType {
public:
  FunctionType(ISession&);
  virtual ~FunctionType();
public: //Lib::IType
  virtual const std::string& name() const;
  virtual Lib::IIterator* iterator();
  virtual Lib::Variable value(Lib::Identifier,const std::string&,void*);
public: //OnX::IType
  virtual void visualize(Lib::Identifier,void*);
private:
  ISession& fSession;
  std::string fName;
};

}

#endif
