#ifndef Lab_Vector_h
#define Lab_Vector_h

// Inheritance :
#include <Lab/Core/BaseObject.h>
#include <Lab/Interfaces/IVector.h>

#include <Lab/Core/Annotation.h>
#include <Lib/Vector.h>

namespace Lab {

class Vector : public BaseObject, public virtual Lab::IVector {
public: //AIDA/IManagedObject
  virtual void* cast(const std::string&) const;
public: //Lab/IVector
  virtual std::string title() const;
  virtual bool setTitle(const std::string&);
  virtual AIDA::IAnnotation& annotation();
  virtual const AIDA::IAnnotation& annotation() const;
  virtual int dimension() const;
  virtual int size() const;
  virtual const std::vector<int>& orders() const;
  virtual bool setValue(const std::vector<int>&,double);
  virtual bool value(const std::vector<int>&,double&) const;
  virtual bool fill(const std::vector<double>&,Cut* = 0);
  virtual bool copy(const IVector& aFrom);
  virtual bool add(const IVector& aVector,Cut* = 0);
  virtual bool subtract(const IVector& aVector);
  virtual bool multiply(const IVector& aVector);
  virtual bool divide(const IVector& aVector);
  virtual bool add(double,Cut* = 0);
  virtual bool multiply(double);
  virtual bool invert();
  virtual bool indices(int,std::vector<int>&) const;
  virtual const std::vector<double>& vector() const;
  virtual std::vector<double>& vector();
  virtual bool accept(int,const Cut&) const;
public: //Lab::BaseObject
  virtual BaseObject* copy(const std::string&) const;
public:
  Vector(IPrinter&,
         const std::string&,
         const std::string&,
         const std::vector<int>&);
  Vector(const std::string&,const Vector&);
  virtual ~Vector();
private:
  std::string fTitle;
  Annotation fAnnotation;
  Lib::Vector<double> fVector;
};

}

#endif
