#ifndef Lab_VectorFactory_h
#define Lab_VectorFactory_h

// Inheritance :
#include <Lab/Core/BaseFactory.h>
#include <Lab/Interfaces/IVectorFactory.h>

class IPrinter;

namespace Lab {

class VectorFactory : public BaseFactory, public virtual Lab::IVectorFactory 
{
public: //Lab::IVectorFactory
  virtual IVector* create(const std::string&,const std::string&,
                                const std::vector<int>&);
  //virtual bool destroy(AIDA::IVector*);
  virtual IVector* add(const std::string&,const IVector&,const IVector&);
  virtual IVector* subtract(const std::string&,const IVector&,const IVector&);
  virtual IVector* multiply(const std::string&,const IVector&,const IVector&);
  virtual IVector* divide(const std::string&,const IVector&,const IVector&);
  virtual IVector* add(const std::string&,const IVector&,double);
  virtual IVector* multiply(const std::string&,const IVector&,double);
public:
  VectorFactory(IPrinter&,AIDA::ITree&);
  virtual ~VectorFactory();
};

}

#endif
