#ifndef Lab_amanip_h
#define Lab_amanip_h

class IPrinter;
namespace AIDA {
  class ITuple;
  class IManagedObject;
  class IFilter;
  class IEvaluator;
  class IHistogram1D;
  class IHistogram2D;
}

#include <string>

namespace Lab {

class amanip {
public:
  static bool is_column_type(const std::string&); 
  static bool compatible_tuples(IPrinter&,const AIDA::ITuple&,const AIDA::ITuple&); 
  static bool copy_tuple(IPrinter&,AIDA::ITuple&,AIDA::ITuple&); 
  static bool copy_tuple_filtered(IPrinter&,AIDA::ITuple&,AIDA::ITuple&,const AIDA::IFilter&); 
  static bool tuple_getDouble(IPrinter&,const AIDA::ITuple&,int,double&); 
  static bool tuple_getString(IPrinter&,const AIDA::ITuple&,int,std::string&); 
  static bool tuple_fill(IPrinter&,AIDA::ITuple&,int,const std::string&); 
  static std::string managed_object_type(const AIDA::IManagedObject&); 
  static std::string managed_object_title(const AIDA::IManagedObject&); 
  static bool tuple_getBooking(IPrinter&,const AIDA::ITuple&,std::string&); 
  static std::string tuple_name(const AIDA::ITuple&);
  static bool tuple_evaluateMin(AIDA::ITuple&,AIDA::IEvaluator&,double&,IPrinter&);
  static bool tuple_evaluateMax(AIDA::ITuple&,AIDA::IEvaluator&,double&,IPrinter&);
  static bool tuple_project(IPrinter&,AIDA::ITuple&,AIDA::IHistogram1D&,int);
  static bool tuple_project(IPrinter&,AIDA::ITuple&,AIDA::IHistogram2D&,int,int);
};
              
}

#endif
