#ifndef Lab_IStore_h
#define Lab_IStore_h

#include <string>

class IStore {
public:
  virtual ~IStore() {}
  virtual void* cast(const std::string&) const = 0;
public:
  virtual bool commit() = 0;
  virtual bool mkdir(const std::string&) = 0;
  virtual bool mkdirs(const std::string&) = 0;
  virtual bool cd(const std::string&) = 0;
  virtual void ls() const = 0;
  virtual std::string path() = 0;
  virtual std::string rootDirectoryName() = 0;
  /**
   * Return directory hierarchy keys in a string at the OnX tree xml format.
   */
  virtual std::string keys(const std::string& = "") = 0; 
};

#endif
