#ifndef Lab_IStoreManager_h
#define Lab_IStoreManager_h

//Inheritance :
#include <Lib/Interfaces/IManager.h>

namespace AIDA {
  class ITree;
  class ITuple;
  class IHistogram1D;
  class IHistogram2D;
}

class IStoreManager : public virtual IManager {
public:
  virtual ~IStoreManager() {}
public:
  virtual AIDA::ITree* createTree(const std::string&,
                                  bool = false, 
                                  bool = false, 
                                  const std::string& = "" ) = 0;
  virtual AIDA::ITuple* createTuple(AIDA::ITree&,
                                    const std::string&,
                                    const std::string&,
                                    const std::string&,
                                    const std::string&) = 0;
  virtual AIDA::IHistogram1D* createHistogram1D(AIDA::ITree&,
                                    const std::string&,
                                    const std::string&,
                                    const std::string&,
                                    int,double,double) = 0;
  virtual AIDA::IHistogram2D* createHistogram2D(AIDA::ITree&,
                                    const std::string&,
                                    const std::string&,
                                    const std::string&,
                                    int,double,double,
                                    int,double,double) = 0;
};

#endif
