#ifndef Lab_MySQLManager_h
#define Lab_MySQLManager_h

#include <Lib/Interfaces/IManager.h>

#include <Lab/Interfaces/IStoreManager.h>

#include <mysql.h>

class ISession;

namespace Lab {

class MySQLManager : public virtual IStoreManager {
public: //IManager
  virtual const std::string& name() const;
  virtual void* cast(const std::string&) const;
public: //IStoreManager
  virtual AIDA::ITree* createTree(const std::string&,
                                  bool = false, 
                                  bool = false, 
                                  const std::string& = "" );
  virtual AIDA::ITuple* createTuple(AIDA::ITree&,
                                    const std::string&,
                                    const std::string&,
                                    const std::string&);
public:
  MySQLManager(ISession&);
  virtual ~MySQLManager();
  MYSQL* mysql() const;
private:
  std::string fName;
  ISession& fSession;
  MYSQL* fMySQL;
  AIDA::ITree* fMemoryTree;
};

}

#endif


