#ifndef Lab_MySQLStore_h
#define Lab_MySQLStore_h

class IPrinter;

#include <Lab/Core/BaseStore.h>

#include <mysql.h>

namespace Lab {

class MySQLManager;

class MySQLStore : public BaseStore {
public: //IStore
  virtual void* cast(const std::string&) const;
  virtual bool commit();
  virtual bool mkdir(const std::string&);
  virtual bool cd(const std::string&);
  virtual void ls() const;
  virtual std::string path();
  virtual std::string keys(); 
  virtual std::string rootDirectoryName();
public:
  virtual ~MySQLStore();
  MySQLStore(IPrinter&,MySQLManager&,const std::string&,const std::string&,int);
  void setVerboseLevel(int);
  void connection(MYSQL*&,MYSQL*&);
private:
  int fVerboseLevel;
  MYSQL* fMySQL;
  MYSQL* fConnection;
};

}

#endif
