#ifndef Lab_RioManager_h
#define Lab_RioManager_h

//Inheritance :
#include <Lab/Interfaces/IStoreManager.h>

class ISession;

namespace Rio {
  class IPrinter;
  class IDictionary;
}

namespace Lab {

class RioPrinter;

class RioManager : public virtual IStoreManager {
public: //IManager
  virtual const std::string& name() const;
  virtual void* cast(const std::string&) const;
public: //IStoreManager
  virtual AIDA::ITree* createTree(const std::string&,
                                  bool = false, 
                                  bool = false, 
                                  const std::string& = "" );
  virtual AIDA::ITuple* createTuple(AIDA::ITree&,
                                    const std::string&,
                                    const std::string&,
                                    const std::string&,
                                    const std::string&);
  virtual AIDA::IHistogram1D* createHistogram1D(AIDA::ITree&,
                                    const std::string&,
                                    const std::string&,
                                    const std::string&,
                                    int,double,double);
  virtual AIDA::IHistogram2D* createHistogram2D(AIDA::ITree&,
                                    const std::string&,
                                    const std::string&,
                                    const std::string&,
                                    int,double,double,
                                    int,double,double);
public:
public:
  RioManager(ISession&);
  virtual ~RioManager();
  Rio::IDictionary& dictionary() const;
  Rio::IPrinter& printer() const;
private:
  std::string fName;
  ISession& fSession;
  RioPrinter* fPrinter;
  Rio::IDictionary* fDictionary;
};

}

#endif


