#ifndef Lab_RioROOT_h
#define Lab_RioROOT_h

namespace HCL {
  class Axis;
  class Histogram;
  class HistogramData;
}

#include <Rio/Core/Named.h>

namespace Lab {

class RioTH : public Rio::Named {
public:
  RioTH(const Rio::IDictionary&);
  virtual ~RioTH();
  bool streamTH1(Rio::IBuffer&,HCL::Histogram&);
  bool streamTH2(Rio::IBuffer&,HCL::Histogram&);
  HCL::Histogram* hclHistogram() const;
protected:
  HCL::Histogram* fHistogram;
  double fEntries;
  double fSw;
};

class RioTH1F : public RioTH {
  RIO_META_HEADER(RioTH1F)
public: //Rio::IObject:
  virtual void* cast(const Rio::IClass&) const;
  virtual bool stream(Rio::IBuffer&);
public:
  RioTH1F(const Rio::IDictionary&);
  RioTH1F(const Rio::IDictionary&,HCL::Histogram*,const std::string&);
  virtual ~RioTH1F();
};

class RioTH1D : public RioTH {
  RIO_META_HEADER(RioTH1D)
public: //Rio::IObject:
  virtual void* cast(const Rio::IClass&) const;
  virtual bool stream(Rio::IBuffer&);
public:
  RioTH1D(const Rio::IDictionary&);
  RioTH1D(const Rio::IDictionary&,HCL::Histogram*,const std::string&);
  virtual ~RioTH1D();
};

class RioTH2F : public RioTH {
  RIO_META_HEADER(RioTH2F)
public: //Rio::IObject:
  virtual void* cast(const Rio::IClass&) const;
  virtual bool stream(Rio::IBuffer&);
public:
  RioTH2F(const Rio::IDictionary&);
  RioTH2F(const Rio::IDictionary&,HCL::Histogram*,const std::string&);
  virtual ~RioTH2F();
};

class RioTH2D : public RioTH {
  RIO_META_HEADER(RioTH2D)
public: //Rio::IObject:
  virtual void* cast(const Rio::IClass&) const;
  virtual bool stream(Rio::IBuffer&);
public:
  RioTH2D(const Rio::IDictionary&);
  RioTH2D(const Rio::IDictionary&,HCL::Histogram*,const std::string&);
  virtual ~RioTH2D();
};

class RioTProfile : public RioTH1D {
  RIO_META_HEADER(RioTProfile)
public: //Rio::IObject:
  virtual void* cast(const Rio::IClass&) const;
  virtual bool stream(Rio::IBuffer&);
public:
  RioTProfile(const Rio::IDictionary&);
  RioTProfile(const Rio::IDictionary&,HCL::Histogram*,const std::string&);
  virtual ~RioTProfile();
};

class RioTVectorD : public Rio::Object {
  RIO_META_HEADER(RioTVectorD)
public: //Rio::IObject:
  virtual void* cast(const Rio::IClass&) const;
  virtual bool stream(Rio::IBuffer&);
public:
  RioTVectorD(const Rio::IDictionary&);
  virtual ~RioTVectorD();
};

class RioTMatrix : public Rio::Object {
  RIO_META_HEADER(RioTMatrix)
public: //Rio::IObject:
  virtual void* cast(const Rio::IClass&) const;
  virtual bool stream(Rio::IBuffer&);
public:
  RioTMatrix(const Rio::IDictionary&);
  virtual ~RioTMatrix();
};

}

#endif
