#ifndef Lab_RioStore_h
#define Lab_RioStore_h

class IPrinter;

namespace Rio {
  class IFile;
  class IDirectory;
}

#include <Lab/Core/BaseStore.h>

namespace Lab {

class RioManager;

class RioStore : public BaseStore {
public: //IStore
  virtual void* cast(const std::string&) const;
  virtual bool commit();
  virtual bool mkdir(const std::string&);
  virtual bool mkdirs(const std::string&);
  virtual bool cd(const std::string&);
  virtual void ls() const;
  virtual std::string path();
  virtual std::string keys(const std::string& = ""); 
  virtual std::string rootDirectoryName();
public:
  virtual ~RioStore();
  RioStore(IPrinter&,
           RioManager&,const std::string&,const std::string& = "READ");
  Rio::IFile* rioFile();
  Rio::IDirectory* directory();
  Rio::IDirectory* findDirectory(const std::string&);
  bool isADirectory(const std::string&);
  Rio::IDirectory* makeDirectories(const std::string&); 
  void setVerboseLevel(int);
  int verboseLevel() const;
  std::string storeName() const;
private:
  void visitTree(Rio::IDirectory&,bool,std::string&); 
private:
  Rio::IFile* fRioFile;
  Rio::IDirectory* fDirectory;
  std::string fFile;
  int fVerboseLevel;
};

}

#endif
