#ifndef Lab_RioTree_h
#define Lab_RioTree_h

// Inheritance :
#include <Lab/Core/MemoryTree.h>

#include <list>

namespace Rio {
  class IDirectory;
}

namespace Lab {

class RioManager;
class RioStore;

// Need a MemoryTree to manage read objects.
class RioTree : public MemoryTree {
public: //IManager
  virtual void* cast(const std::string&) const;
public: //AIDA/ITree
  virtual AIDA::IManagedObject* find(const std::string&);
  virtual bool cd(const std::string&);
  virtual bool mkdir(const std::string&);
  virtual bool mkdirs ( const std::string&);
  virtual bool commit();
  virtual std::string findPath(const AIDA::IManagedObject&) const;
  virtual bool ls(const std::string & = ".", bool = false,std::ostream& = std::cout) const;
  virtual bool rm(const std::string&);
  virtual std::string pwd() const;
  virtual bool rmdir ( const std::string&);
  virtual std::string storeName() const;
  virtual bool cp(const std::string&,const std::string&,bool = false );
  virtual std::vector<std::string> listObjectNames(const std::string& = ".", bool = false) const;
  virtual std::vector<std::string> listObjectTypes(const std::string& = ".", bool = false) const;
public: //Lab::BaseTree.
  virtual bool addObject(BaseObject*,const std::string&);
  virtual std::string hierarchy() const; 
  virtual void setVerboseLevel(int);
public:
  RioTree(ISession&,const std::string&,bool,bool,RioManager&,int,
          const std::string&);
  virtual ~RioTree();
  RioStore* rioStore() const;
  bool store(Rio::IDirectory&,const AIDA::IManagedObject&,const std::string&);
  std::string pathInStore(const std::string&) const;
private:
  bool import(Rio::IDirectory&,const std::string&);
  BaseObject* retreive(Rio::IDirectory&,const std::string&);
private:
  std::string fStoreName;
  RioStore* fStore;
  bool f2ROOT;
};

}

#endif
