#ifndef Lab_RioTuple_h
#define Lab_RioTuple_h

#include <Lab/Core/BaseTuple.h>

namespace Rio { 
 class IDirectory;
 class Tree;
}

namespace Lab {

class RioTuple : public BaseTuple {
public: //AIDA/ITuple
  //fill :
  virtual bool fill(int,double);
  virtual bool fill(int,float);
  virtual bool fill(int,int);
  virtual bool fill(int,short);
  virtual bool fill(int,long);
  virtual bool fill(int,char);
  virtual bool fill(int,bool);
  virtual bool fill(int,const std::string&);
  virtual bool fill(int,const AIDA::ITupleEntry&);
  virtual bool fill(const std::vector<double>&);
  virtual bool fill(const std::vector<float>&);
  //get :
  virtual double getDouble(int) const;
  virtual float getFloat(int) const;
  virtual int getInt(int) const;
  virtual short getShort(int) const;
  virtual long getLong(int) const;
  virtual char getChar(int) const;
  virtual bool getBoolean(int) const;
  virtual std::string getString(int) const;
  virtual const AIDA::ITupleEntry* getObject(int) const;
  //else :
  virtual void* cast(const std::string&) const;
  virtual bool setTitle(const std::string&);
  virtual bool addRow();
  virtual int rows() const;
  virtual const AIDA::ITuple* getTuple(int) const;
  virtual AIDA::ITuple* getTuple(int);
  virtual double columnMin(int column) const;
  virtual double columnMax(int column) const;
  virtual double columnMean(int column) const;
  virtual double columnRms(int column) const;
public: //Lab::BaseObject
  virtual BaseObject* copy(const std::string&) const;
public: //Lab::BaseTuple
  virtual unsigned char getByte(int) const;
  virtual bool fill33(int,unsigned char);
public:
  RioTuple(IPrinter&,Rio::IDirectory&,const std::string&,
           const std::string&,const std::string&,int);
  RioTuple(IPrinter&,const std::string&,Rio::Tree*,int);
  virtual ~RioTuple();
  bool isValid() const;
private:
  void addColumn(const std::string&,const std::string&);
private:
  Rio::Tree* fRioTree;
  int fVerboseLevel;
};

}

#endif


