#ifndef Lab_XML_Manager_h
#define Lab_XML_Manager_h

#include <Lib/Interfaces/IManager.h>

#include <Lab/Interfaces/IStoreManager.h>

class ISession;

namespace Lab {

class XML_Manager : public virtual IStoreManager {
public: //IManager
  virtual const std::string& name() const;
  virtual void* cast(const std::string&) const;
public: //IStoreManager
  virtual AIDA::ITree* createTree(const std::string&,
                                  bool = false, 
                                  bool = false, 
                                  const std::string& = "" );
  virtual AIDA::ITuple* createTuple(AIDA::ITree&,
                                    const std::string&,
                                    const std::string&,
                                    const std::string&,
                                    const std::string&);
  virtual AIDA::IHistogram1D* createHistogram1D(AIDA::ITree&,
                                    const std::string&,
                                    const std::string&,
                                    const std::string&,
                                    int,double,double);
  virtual AIDA::IHistogram2D* createHistogram2D(AIDA::ITree&,
                                    const std::string&,
                                    const std::string&,
                                    const std::string&,
                                    int,double,double,
                                    int,double,double);
public:
public:
  XML_Manager(ISession&);
  virtual ~XML_Manager();
private:
  std::string fName;
  ISession& fSession;
  AIDA::ITree* fMemoryTree;
};

}

#endif


