#ifndef Lab_ZebraManager_h
#define Lab_ZebraManager_h

// Inheritance :
#include <Lab/Interfaces/IStoreManager.h>

class ISession;

namespace Lab {

class ZebraPrinter;

class ZebraManager : public virtual IStoreManager {
public: //IManager
  virtual const std::string& name() const;
  virtual void* cast(const std::string&) const;
public: //IStoreManager
  virtual AIDA::ITree* createTree(const std::string&,
                                  bool = false, 
                                  bool = false, 
                                  const std::string& = "" );
  virtual AIDA::ITuple* createTuple(AIDA::ITree&,
                                    const std::string&,
                                    const std::string&,
                                    const std::string&,
                                    const std::string&);
  virtual AIDA::IHistogram1D* createHistogram1D(AIDA::ITree&,
                                    const std::string&,
                                    const std::string&,
                                    const std::string&,
                                    int,double,double);
  virtual AIDA::IHistogram2D* createHistogram2D(AIDA::ITree&,
                                    const std::string&,
                                    const std::string&,
                                    const std::string&,
                                    int,double,double,
                                    int,double,double);
public:
  ZebraManager(ISession&);
  virtual ~ZebraManager();
  int* get_pawc();
  int* get_quest();
  int* get_hcbits();
  int* get_hcbook();
  int* get_rzcl();
private:
  std::string fName;
  ISession& fSession;
};

}

#endif


