#ifndef Lab_ZebraTree_h
#define Lab_ZebraTree_h

#include <Lab/Core/MemoryTree.h>

#include <list>

namespace Zebra {
  class IDirectory;
}

namespace Lab {

class ZebraManager;

// Need a MemoryTree to manage read objects.
class ZebraTree : public MemoryTree {
public: //IManager
  virtual void* cast(const std::string&) const;
public: //AIDA/ITree
  virtual std::string storeName() const;
public:
  ZebraTree(ISession&,const std::string&,bool,bool,ZebraManager&,int);
  virtual ~ZebraTree();
  bool isValid() const;
private:
  void convertDirectory();
  void convertHistogram1D(int);
  void convertHistogram2D(int);
  void convertProfile(int);
  void convertColumnWiseTuple(int);
  void convertRowWiseTuple(int);
private:
  std::string fStoreName;
  ZebraManager& fManager;
  bool fIsValid;
  std::string fDirectory;
  int fUnit;
  bool fWriting;
};

}

#endif
