
#
# To start Lab AIDA implementation from a Python shell prompt :
#   OS> <setup Lab>
#   OS> python2
#   >>> import AIDA
# 
# Execute some script (for exa Lab/examples/Python/AIDA_exa_0.py) with :
#   >>> import aidaex0
#
# Some Lab/examples/Python/*.py scripts may not do 
# plotter.show() and plotter.interact().
# In order to see the GUI (and plotter) when starting
# one of these scripts from the python shell,
# someone has to do :
#   >>> import <script>
#   >>> AIDA.ui.show('')
#   >>> AIDA.ui.steer()
# or the short cut :
#   >>> AIDA.show()
#
# When under the GUI, a OnX/Python> ui.exit() or a OnX/File/Exit
# gives control back to the python shell.
# Then a :
#   >>> AIDA.ui.steer()
# gives control again to the GUI.
#
# To quit properly from the python shell prompt :
#   >>> del AIDA.onx
#   >>> <CTRL-D>
#

import sys
if not sys.__dict__.has_key('OnX_session'):
  # OnX session is not here.
  # Probably executed from the Python shell.
  # Create one :
  from OnX_SWIG import OnX_OnX

  onx = OnX_OnX(0)
  from OnX_SWIG import IManager_to_IScriptManager
  scriptManager = IManager_to_IScriptManager(onx.session().findManager('ScriptManager'))
  # Initialiaze OnX/Python that will create a PySys OnX_session object :
  scriptManager.executeScript('Python',' ');

  # 0 to not show the GUI at startup.
  ui = onx.createUI('','',0)
  #ui = onx.createUI('','Xt',0)
  #ui = onx.createUI('','Gtk',0)
  #ui = onx.createUI('','Qt',0,0)

  # A shortcut to show the GUI and give control to it :
  def show():
    ui.show("")
    ui.steer()
else:
  # Probably executed from an OnX GUI.
  from OnX_SWIG import OnX_getSession,IManager_to_IUI
  session = OnX_getSession()
  ui = IManager_to_IUI(session.findManager('UI_Manager'))

# AIDA Python/C++ SWIG wrapping :
from Lab_SWIG import *

# Get session in order to define AIDA_createAnalysisFactory :
from OnX_SWIG import *
session = OnX_getSession()

def AIDA_createAnalysisFactory():
  return IManager_to_IAnalysisFactory(session.findManager('AnalysisFactory'))
