
def region_set_axes_color(aRegion,aColor):
  aRegion.setParameter("plotter.xAxis.lineStyle.color",aColor)
  aRegion.setParameter("plotter.xAxis.ticksStyle.color",aColor)
  aRegion.setParameter("plotter.xAxis.labelsStyle.color",aColor)
  aRegion.setParameter("plotter.xAxis.titleStyle.color",aColor)
  aRegion.setParameter("plotter.xAxis.magStyle.color",aColor)

  aRegion.setParameter("plotter.yAxis.lineStyle.color",aColor)
  aRegion.setParameter("plotter.yAxis.ticksStyle.color",aColor)
  aRegion.setParameter("plotter.yAxis.labelsStyle.color",aColor)
  aRegion.setParameter("plotter.yAxis.titleStyle.color",aColor)
  aRegion.setParameter("plotter.yAxis.magStyle.color",aColor)

  aRegion.setParameter("plotter.zAxis.lineStyle.color",aColor)
  aRegion.setParameter("plotter.zAxis.ticksStyle.color",aColor)
  aRegion.setParameter("plotter.zAxis.labelsStyle.color",aColor)
  aRegion.setParameter("plotter.zAxis.titleStyle.color",aColor)
  aRegion.setParameter("plotter.zAxis.magStyle.color",aColor)

def region_set_axes_text_scale(aRegion,aValue):
  aRegion.setParameter("plotter.textScale",aValue)

  aRegion.setParameter("plotter.xAxis.labelsStyle.scale",aValue)
  aRegion.setParameter("plotter.xAxis.titleStyle.scale",aValue)
  aRegion.setParameter("plotter.xAxis.magStyle.scale",aValue)

  aRegion.setParameter("plotter.yAxis.labelsStyle.scale",aValue)
  aRegion.setParameter("plotter.yAxis.titleStyle.scale",aValue)
  aRegion.setParameter("plotter.yAxis.magStyle.scale",aValue)

  aRegion.setParameter("plotter.zAxis.labelsStyle.scale",aValue)
  aRegion.setParameter("plotter.zAxis.titleStyle.scale",aValue)
  aRegion.setParameter("plotter.zAxis.magStyle.scale",aValue)

def region_set_axes_line_pattern(aRegion,aValue):
  aRegion.setParameter("plotter.xAxis.lineStyle.pattern",aValue)
  aRegion.setParameter("plotter.yAxis.lineStyle.pattern",aValue)
  aRegion.setParameter("plotter.zAxis.lineStyle.pattern",aValue)

def region_set_axes_line_width(aRegion,aValue):
  aRegion.setParameter("plotter.xAxis.lineStyle.width",aValue)
  aRegion.setParameter("plotter.yAxis.lineStyle.width",aValue)
  aRegion.setParameter("plotter.zAxis.lineStyle.width",aValue)

  aRegion.setParameter("plotter.xAxis.ticksStyle.width",aValue)
  aRegion.setParameter("plotter.yAxis.ticksStyle.width",aValue)
  aRegion.setParameter("plotter.zAxis.ticksStyle.width",aValue)

def region_set_axes_ticks_length(aRegion,aValue):
  aRegion.setParameter("plotter.xAxis.tickLength",aValue)
  aRegion.setParameter("plotter.yAxis.tickLength",aValue)
  aRegion.setParameter("plotter.zAxis.tickLength",aValue)

def region_set_axes_title_height(aRegion,aValue):
  aRegion.setParameter("plotter.xAxis.titleHeight",aValue)
  aRegion.setParameter("plotter.yAxis.titleHeight",aValue)
  aRegion.setParameter("plotter.zAxis.titleHeight",aValue)

def region_set_axes_label_height(aRegion,aValue):
  aRegion.setParameter("plotter.xAxis.labelHeight",aValue)
  aRegion.setParameter("plotter.yAxis.labelHeight",aValue)
  aRegion.setParameter("plotter.zAxis.labelHeight",aValue)

def region_set_style_ROOT_Default(aRegion):
  #// From ROOT-4.00.08 TStyle::Reset method.

  # To have a good matching with ROOT for text size :
  #FIXME : avoid this below cooking...
  majic = "0.6"

  XLAB = 1.4/20.0 #0.07 #x distance of y title to data frame.
  YLAB = 0.8/20.0 #0.04 #y distance of x title to data frame.

  YLAB = "0.05" #FIXME : cooking.

  smooth = "TRUE"
  black = "0 0 0"
  font_62 = "TTF/arialbd"
  grey_19 = "0.95 0.95 0.95"

  line_solid  = "0xFFFF"
  line_dashed = "0x00FF"
  line_dotted = "0x0101"
  line_dash_dotted = "0x1C47"

  aRegion.setParameter("plotterViewportMapping","ADJUST_VIEWPORT")

  aRegion.setParameter("infosRegionAttachedToDataFrame","FALSE")

  aRegion.setParameter("plotter.width","1")
  aRegion.setParameter("plotter.height","1")

  region_set_axes_color(aRegion,black)

  aRegion.setParameter("legendRegionVisible","FALSE")

  aRegion.setParameter("plotter.wallStyle.visible","FALSE")
  aRegion.setParameter("plotter.binsStyle[0].modeling","top_lines")

  # axes :
  region_set_axes_text_scale(aRegion,majic)
  region_set_axes_line_pattern(aRegion,line_solid)
  region_set_axes_line_width(aRegion,"0")

  # X axis :
  aRegion.setParameter("plotter.xAxis.modeling","hplot")
  aRegion.setParameter("plotter.xAxis.titleStyle.visible","TRUE")
  aRegion.setParameter("plotter.xAxis.divisions","510")
  aRegion.setParameter("plotter.xAxis.lineStyle.color",black)
  aRegion.setParameter("plotter.xAxis.labelsStyle.color",black)
  aRegion.setParameter("plotter.xAxis.labelsStyle.fontName",font_62)
  aRegion.setParameter("plotter.xAxis.labelsStyle.smoothing",smooth)
  aRegion.setParameter("plotter.xAxis.titleStyle.color",black)
  aRegion.setParameter("plotter.xAxis.titleStyle.fontName",font_62)
  aRegion.setParameter("plotter.xAxis.titleStyle.smoothing",smooth)
  aRegion.setParameter("plotter.xAxis.labelToAxis","0.005")
  aRegion.setParameter("plotter.xAxis.labelHeight","0.04")
  aRegion.setParameter("plotter.xAxis.tickLength","0.03")
  aRegion.setParameter("plotter.xAxis.titleToAxis",YLAB)
  aRegion.setParameter("plotter.xAxis.titleHeight","0.04")
  aRegion.setParameter("plotter.xAxis.titleToAxisJustification","RIGHT")
  # Y axis :
  aRegion.setParameter("plotter.yAxis.modeling","hplot")
  aRegion.setParameter("plotter.yAxis.titleStyle.visible","TRUE")
  aRegion.setParameter("plotter.yAxis.divisions","510")
  aRegion.setParameter("plotter.yAxis.lineStyle.color",black)
  aRegion.setParameter("plotter.yAxis.labelsStyle.color",black)
  aRegion.setParameter("plotter.yAxis.labelsStyle.fontName",font_62)
  aRegion.setParameter("plotter.yAxis.labelsStyle.smoothing",smooth)
  aRegion.setParameter("plotter.yAxis.titleStyle.color",black)
  aRegion.setParameter("plotter.yAxis.titleStyle.fontName",font_62)
  aRegion.setParameter("plotter.yAxis.titleStyle.smoothing",smooth)
  aRegion.setParameter("plotter.yAxis.labelToAxis","0.005")
  aRegion.setParameter("plotter.yAxis.labelHeight","0.04")
  aRegion.setParameter("plotter.yAxis.tickLength","0.03")
  aRegion.setParameter("plotter.yAxis.titleToAxis",YLAB)
  aRegion.setParameter("plotter.yAxis.titleHeight","0.04")
  aRegion.setParameter("plotter.yAxis.titleToAxisJustification","RIGHT")

  aRegion.setParameter("viewportRegion.background","TRUE")
  aRegion.setParameter("viewportRegion.backgroundColor",grey_19)
  aRegion.setParameter("viewportRegion.horizontalBorder","1")
  aRegion.setParameter("viewportRegion.verticalBorder","1")

  aRegion.setParameter("plotter.bottomMargin","0.1")
  aRegion.setParameter("plotter.topMargin","0.1")
  aRegion.setParameter("plotter.leftMargin","0.1")
  aRegion.setParameter("plotter.rightMargin","0.1")

  aRegion.setParameter("plotter.gridStyle.visible","FALSE")
  aRegion.setParameter("plotter.rightAxisVisible","FALSE")
  aRegion.setParameter("plotter.topAxisVisible","FALSE")

  aRegion.setParameter("plotter.functionStyle[0].color",black)
  aRegion.setParameter("plotter.functionStyle[0].linePattern",line_solid)
  aRegion.setParameter("plotter.functionStyle[0].lineWidth","0")

  aRegion.setParameter("plotter.gridStyle.color",black)

  aRegion.setParameter("plotter.binsStyle[0].color",black)
  aRegion.setParameter("plotter.binsStyle[0].linePattern",line_solid)
  aRegion.setParameter("plotter.binsStyle[0].lineWidth","1")

  aRegion.setParameter("plotter.innerFrameStyle.color",black)
  aRegion.setParameter("plotter.innerFrameStyle.linePattern",line_solid)
  aRegion.setParameter("plotter.innerFrameStyle.lineWidth","1")

  aRegion.setParameter("plotter.xAxis.logScale","FALSE")
  aRegion.setParameter("plotter.yAxis.logScale","FALSE")

  aRegion.setParameter("infosRegionVisible","TRUE")
  aRegion.setParameter("infosRegionResizePolicy","RESIZE_HEIGHT")
  aRegion.setParameter("infosRegionStyle","ROOT")
  aRegion.setParameter("infosRegion.inBetweenSpaces","2")
  aRegion.setParameter("plotter.infosStyle.options","name entries mean rms")

  aRegion.setParameter("plotter.titleStyle.visible","FALSE")
  aRegion.setParameter("titleRegionVisible","TRUE")

  aRegion.setParameter("infosRegion.viewportRegion.backgroundColor",grey_19)
  aRegion.setParameter("infosRegion.viewportRegion.horizontalBorder","1")
  aRegion.setParameter("infosRegion.viewportRegion.verticalBorder","1")
  aRegion.setParameter("infosRegion.viewportRegion.horizontalShadow","2")
  aRegion.setParameter("infosRegion.viewportRegion.verticalShadow","-2")

  aRegion.setParameter("infosRegion.textStyle.color",black)
  aRegion.setParameter("infosRegion.textStyle.fontName",font_62)
  aRegion.setParameter("infosRegion.textStyle.smoothing",smooth)

  aRegion.setParameter("infosRegion.lineStyle.color",black)
  aRegion.setParameter("infosRegion.lineStyle.width","1")
  aRegion.setParameter("infosRegionSize","0.2 0.16")
  aRegion.setParameter("infosRegionOrigin","0.02 0.005") #PERCENT : ur info to ur plotter.

  aRegion.setParameter("titleRegion.viewportRegion.backgroundColor",grey_19)
  aRegion.setParameter("titleRegion.viewportRegion.horizontalBorder","1")
  aRegion.setParameter("titleRegion.viewportRegion.verticalBorder","1")
  aRegion.setParameter("titleRegion.viewportRegion.horizontalShadow","2")
  aRegion.setParameter("titleRegion.viewportRegion.verticalShadow","-2")

  aRegion.setParameter("titleRegion.styles[0].color",black)
  aRegion.setParameter("titleRegion.styles[0].fontName",font_62)
  aRegion.setParameter("titleRegion.styles[0].smoothing",smooth)
  aRegion.setParameter("titleRegionSize","0.3 0.05") #width automatic.
  aRegion.setParameter("titleRegionOrigin","0.01 0.005") #PERCENT ul title to ul plotter.

def region_set_style_PAW_Default(aRegion):
  #// Must be in sync with Lab/source/PAW/PAW_Manager/regionSetLayout.

  aRegion.setParameter("plotterViewportMapping","LEAVE_ALONE")

  aRegion.setParameter("infosRegionAttachedToDataFrame","TRUE")

  aRegion.setParameter("viewportRegion.background","TRUE")
  aRegion.setParameter("viewportRegion.backgroundColor","1 1 1")

  aRegion.setParameter("plotter.titleUp","FALSE")
  aRegion.setParameter("plotter.wallStyle.visible","FALSE")
  aRegion.setParameter("plotter.gridStyle.visible","FALSE")
  aRegion.setParameter("plotter.innerFrameStyle.visible","TRUE")
  aRegion.setParameter("plotter.rightAxisVisible","FALSE")
  aRegion.setParameter("plotter.topAxisVisible","FALSE")

  aRegion.setParameter("plotter.colorMapping","")

  aRegion.setParameter("titleRegionVisible","FALSE")

  font = "Hershey"
  aRegion.setParameter("infosRegion.textStyle.fontName",font)
  aRegion.setParameter("infosRegionResizePolicy","ASPECT_RATIO")
  aRegion.setParameter("infosRegion.viewportRegion.horizontalShadow","0")
  aRegion.setParameter("infosRegion.viewportRegion.verticalShadow","0")
  aRegion.setParameter("infosRegionStyle","PAW");
  aRegion.setParameter("infosRegion.viewportRegion.backgroundColor","1 1 1");
  aRegion.setParameter("infosRegion.inBetweenSpaces","10")

  aRegion.setParameter("legendRegionVisible","FALSE")
  aRegion.setParameter("legendRegion.viewportRegion.horizontalShadow","0")
  aRegion.setParameter("legendRegion.viewportRegion.verticalShadow","0")

  aRegion.setParameter("plotter.xAxis.modeling","hplot")
  aRegion.setParameter("plotter.yAxis.modeling","hplot")
  aRegion.setParameter("plotter.zAxis.modeling","hplot")
  aRegion.setParameter("plotter.xAxis.titleStyle.encoding","PAW")
  aRegion.setParameter("plotter.yAxis.titleStyle.encoding","PAW")
  aRegion.setParameter("plotter.zAxis.titleStyle.encoding","PAW")

  aRegion.setParameter("plotter.xAxis.lineStyle.color","0 0 0")
  aRegion.setParameter("plotter.xAxis.ticksStyle.color","0 0 0")
  aRegion.setParameter("plotter.xAxis.labelsStyle.color","0 0 0")
  aRegion.setParameter("plotter.xAxis.titleStyle.color","0 0 0")
  aRegion.setParameter("plotter.xAxis.magStyle.color","0 0 0")
  aRegion.setParameter("plotter.xAxis.titleToAxisJustification","RIGHT")

  aRegion.setParameter("plotter.yAxis.lineStyle.color","0 0 0")
  aRegion.setParameter("plotter.yAxis.ticksStyle.color","0 0 0")
  aRegion.setParameter("plotter.yAxis.labelsStyle.color","0 0 0")
  aRegion.setParameter("plotter.yAxis.titleStyle.color","0 0 0")
  aRegion.setParameter("plotter.yAxis.magStyle.color","0 0 0")
  aRegion.setParameter("plotter.yAxis.titleToAxisJustification","RIGHT")

  aRegion.setParameter("plotter.zAxis.lineStyle.color","0 0 0")
  aRegion.setParameter("plotter.zAxis.ticksStyle.color","0 0 0")
  aRegion.setParameter("plotter.zAxis.labelsStyle.color","0 0 0")
  aRegion.setParameter("plotter.zAxis.titleStyle.color","0 0 0")
  aRegion.setParameter("plotter.zAxis.magStyle.color","0 0 0")
  aRegion.setParameter("plotter.zAxis.titleToAxisJustification","RIGHT")

  #TFON
  aRegion.setParameter("plotter.titleStyle.fontName",font)
  #VFON
  aRegion.setParameter("plotter.xAxis.labelsStyle.fontName",font)
  aRegion.setParameter("plotter.yAxis.labelsStyle.fontName",font)
  aRegion.setParameter("plotter.zAxis.labelsStyle.fontName",font)
  #LFONT
  aRegion.setParameter("plotter.xAxis.titleStyle.fontName",font)
  aRegion.setParameter("plotter.yAxis.titleStyle.fontName",font)
  aRegion.setParameter("plotter.zAxis.titleStyle.fontName",font)

  XSIZ = "20"
  YSIZ = "20"
  aRegion.setParameter("plotter.width",XSIZ)
  aRegion.setParameter("plotter.height",YSIZ)

  XMGL = "2"
  XMGR = "2"
  YMGL = "2"
  YMGU = "2"
  aRegion.setParameter("plotter.leftMargin",XMGL)
  aRegion.setParameter("plotter.rightMargin",XMGR)
  aRegion.setParameter("plotter.bottomMargin",YMGL)
  aRegion.setParameter("plotter.topMargin",YMGU)
  #FIXME : Have infos box within upper right corner of data frame.

  ZSIZ = "20"
  aRegion.setParameter("plotter.depth",ZSIZ)
  ZMGD = "2"
  ZMGU = "2"
  aRegion.setParameter("plotter.downMargin",ZMGD)
  aRegion.setParameter("plotter.upMargin",ZMGU)

  YHTI = "1.2"
  TSIZ = "0.28"

  HTIT = "HTIT" #"UTIT"
  if HTIT == "HTIT":
    aRegion.setParameter("plotter.titleStyle.visible","TRUE")
    aRegion.setParameter("plotter.titleAutomated","TRUE")
    aRegion.setParameter("plotter.titleUp","FALSE")
    aRegion.setParameter("plotter.titleHeight",TSIZ)
    aRegion.setParameter("plotter.titleToAxis",YHTI)
  else:
    UTIT = ""
    if UTIT == "":
      aRegion.setParameter("plotter.titleStyle.visible","FALSE")
    else:
      aRegion.setParameter("plotter.titleStyle.visible","TRUE")
      aRegion.setParameter("plotter.titleAutomated","FALSE")
      aRegion.setParameter("plotter.titleUp","FALSE")
      aRegion.setParameter("plotter.titleHeight",TSIZ)
      aRegion.setParameter("plotter.titleToAxis",YHTI)
      aRegion.setParameter("plotter.title",fUTIT)

  #Axis title SIZe
  ASIZ = "0.28"
  aRegion.setParameter("plotter.xAxis.titleHeight",ASIZ)
  aRegion.setParameter("plotter.yAxis.titleHeight",ASIZ)

  #y length of X axis ticks. Def 0.015 
  XTIC = "0.3"
  aRegion.setParameter("plotter.xAxis.tickLength",XTIC)

  #x length of Y axis ticks. Def 0.015 
  YTIC = "0.3"
  aRegion.setParameter("plotter.yAxis.tickLength",YTIC)

  #y distance of x tick label to data frame. Def 0.02 
  YVAL = "0.4"
  aRegion.setParameter("plotter.xAxis.labelToAxis",YVAL)

  #x distance of y tick label to data frame. Def 0.02 
  XVAL = "0.4"
  aRegion.setParameter("plotter.yAxis.labelToAxis",XVAL)

  #y distance of x title to data frame. Def 0.04  
  YLAB = "0.8"
  aRegion.setParameter("plotter.xAxis.titleToAxis",YLAB)

  #x distance of y title to data frame. Def 0.07  
  XLAB = "1.4"
  aRegion.setParameter("plotter.yAxis.titleToAxis",XLAB)

  # axis labels SIZe. Def : 0.28F.
  VSIZ = "0.28"
  aRegion.setParameter("plotter.xAxis.labelHeight",VSIZ)
  aRegion.setParameter("plotter.yAxis.labelHeight",VSIZ)
  aRegion.setParameter("plotter.zAxis.labelHeight",VSIZ)

  LINX = "LINX" #"LOGX"
  if LINX == "LOGX":
    aRegion.setParameter("plotter.xAxisLogScale","TRUE")
  else:
    aRegion.setParameter("plotter.xAxisLogScale","FALSE")

  LINY = "LINY" #"LOGY"
  if LINY == "LOGY":
    aRegion.setParameter("plotter.yAxisLogScale","TRUE")
  else:
    aRegion.setParameter("plotter.yAxisLogScale","FALSE")

  LINZ = "LINZ" #"LOGZ"
  if LINZ == "LOG":
    aRegion.setParameter("plotter.zAxisLogScale","TRUE")
  else:
    aRegion.setParameter("plotter.zAxisLogScale","FALSE")

  NDVX = "10510"
  aRegion.setParameter("plotter.xAxis.divisions",NDVX)

  NDVY = "10510"
  aRegion.setParameter("plotter.yAxis.divisions",NDVY)

  NDVZ = "10510"
  aRegion.setParameter("plotter.zAxis.divisions",NDVZ)

  #  BWID  //  1   // Box line WIDth      
  BWID = "1"
  #BWID = MAXIMUM(int(BWID/2.2),1)  //From graflib/higz/ikernel/islwsc.F
  aRegion.setParameter("plotter.innerFrameStyle.lineWidth",BWID)
  aRegion.setParameter("plotter.xAxis.lineStyle.width",BWID)
  aRegion.setParameter("plotter.yAxis.lineStyle.width",BWID)

  #  PWID  //  1   // Picture line WIDth  

  #  XWID  //  1   // X ticks WIDth       
  XWID = "1"
  #XWID = MAXIMUM(int(XWID/2.2),1)  //From graflib/higz/ikernel/islwsc.F
  aRegion.setParameter("plotter.xAxis.ticksStyle.width",XWID)

  #  YWID  //  1   // Y ticks WIDth       
  YWID = "1"
  #YWID = MAXIMUM(int(YWID/2.2),1)  //From graflib/higz/ikernel/islwsc.F
  aRegion.setParameter("plotter.yAxis.ticksStyle.width",YWID)

  #  CWID  // 0.50 // Color map WIDth     

  NGRI = "NGRI"
  if NGRI == "NGRI":
    aRegion.setParameter("plotter.gridStyle.visible","FALSE")
  else:
    aRegion.setParameter("plotter.gridStyle.visible","TRUE")

  # STAT infos :
  # STAT = "1111"  # [OURMEI]  //default 1111
  # O=1 overflow
  # U=1 underflow
  # R=1 RMS
  # M=1 mean
  # E=1 entries
  # I=1 ID
  STAT = "name entries mean rms"  #others : underflow overflow

  # FIT infos :
  # PAW set FIT [CEP] //default 101
  #    C = 1  print Chisquare/Number of degress of freedom
  #    E = 1  print errors (if e=1, v must be 1)
  #    P = 1  print name/values of parameters
  FIT = "fit_quality fit_ndf fit_parameters"   #others : fit_errors

  NSTA = "NSTA" #"STA"
  NFIT = "NFIT" #"FIT"

  if NSTA=="STA" or NFIT=="FIT":
    aRegion.setParameter("infosRegionVisible","TRUE")
    aRegion.setParameter("plotter.infosStyle.options",STA+FIT)
  else:
    aRegion.setParameter("infosRegionVisible","FALSE")

  # Data :
  #  HWID  //  1   // Histogram line WIDth
  HWID = "1"
  #HWID = MAXIMUM(int(HWID/2.2),1)  //From graflib/higz/ikernel/islwsc.F

  #  FWID  //  1   // Function line WIDth 
  FWID = "1"
  #FWID = MAXIMUM(int(FWID/2.2),1)  //From graflib/higz/ikernel/islwsc.F

  SOLID = "0xFFFF"
  #DASHED "0x00FF"
  #DOTTED "0x0101"
  #DASH_DOTTED "0x1C47"

  for index in range(0,11):
    s = "%d" % index

    # bins :
    aRegion.setParameter("plotter.binsStyle["+s+"].color","0 0 0")
    aRegion.setParameter("plotter.binsStyle["+s+"].linePattern",SOLID)
    aRegion.setParameter("plotter.binsStyle["+s+"].markerStyle","CROSS")
    aRegion.setParameter("plotter.binsStyle["+s+"].modeling","top_lines")
    aRegion.setParameter("plotter.binsStyle["+s+"].lineWidth",HWID)

    aRegion.setParameter("plotter.rightHatchStyle["+s+"].color","0 0 0")
    aRegion.setParameter("plotter.rightHatchStyle["+s+"].linePattern",SOLID)
    aRegion.setParameter("plotter.rightHatchStyle["+s+"].lineWidth","1")
    aRegion.setParameter("plotter.rightHatchStyle["+s+"].angle","0.7854")
    aRegion.setParameter("plotter.rightHatchStyle["+s+"].spacing","0.05")
    aRegion.setParameter("plotter.rightHatchStyle["+s+"].offset","0")

    aRegion.setParameter("plotter.leftHatchStyle["+s+"].color","0 0 0")
    aRegion.setParameter("plotter.leftHatchStyle["+s+"].linePattern",SOLID)
    aRegion.setParameter("plotter.leftHatchStyle["+s+"].lineWidth","1")
    aRegion.setParameter("plotter.leftHatchStyle["+s+"].angle","0.7854")
    aRegion.setParameter("plotter.leftHatchStyle["+s+"].spacing","0.05")
    aRegion.setParameter("plotter.leftHatchStyle["+s+"].offset","0")

    aRegion.setParameter("plotter.errorsStyle["+s+"].visible","FALSE")

    # points :
    aRegion.setParameter("plotter.pointsStyle["+s+"].color","0 0 0")
    aRegion.setParameter("plotter.pointsStyle["+s+"].linePattern",SOLID)
    aRegion.setParameter("plotter.pointsStyle["+s+"].markerStyle","CROSS")
    aRegion.setParameter("plotter.pointsStyle["+s+"].modeling","lines")

    # functions :
    aRegion.setParameter("plotter.functionStyle["+s+"].color","0 0 0")
    aRegion.setParameter("plotter.functionStyle["+s+"].linePattern",SOLID)
    aRegion.setParameter("plotter.functionStyle["+s+"].lineWidth",FWID)

def ROOT_Default():
  from AIDA import AIDA_createAnalysisFactory
  aida = AIDA_createAnalysisFactory()
  # Get current plotter :
  plotterFactory = aida.createPlotterFactory()
  plotter = plotterFactory.create('')
  del plotterFactory
  region = plotter.currentRegion()
  region_set_style_ROOT_Default(region)
  del plotter
  del aida

def PAW_Default():
  from AIDA import AIDA_createAnalysisFactory
  aida = AIDA_createAnalysisFactory()
  # Get current plotter :
  plotterFactory = aida.createPlotterFactory()
  plotter = plotterFactory.create('')
  del plotterFactory
  region = plotter.currentRegion()
  region_set_style_PAW_Default(region)
  del plotter
  del aida


