
from Lab import *

#///////////////////////////////////////////////////////
# Tree procedures :
#///////////////////////////////////////////////////////
def RootTree( aFile, aMode ):
  fac = aida.createTreeFactory()
  if aMode == 'READ':
    obj = fac.create(aFile,1,1,'ROOT')
  elif aMode == 'UPDATE':
    obj = fac.create(aFile,0,1,'ROOT')
  else:
    obj = fac.create(aFile,0,0,'ROOT')
  del_ITreeFactory(fac)
  return obj

def AsciiTree( aFile ):
  fac = aida.createTreeFactory()
  obj = fac.create(aFile,0,0,'ASCII')
  del_ITreeFactory(fac)
  return obj

def DestroyTree(aTree):
 session.destroyManager(aTree.storeName().c_str())

#///////////////////////////////////////////////////////
# Histogram procedures :
#///////////////////////////////////////////////////////
def H1D( aName, aLabel, aXnumber, aXmin, aXmax, aTree = memoryTree):
 fac = aida.createHistogramFactory(aTree)
 obj = fac.create1D(aName,aLabel,aXnumber,aXmin,aXmax)
 del_IHistogramFactory(fac)
 return obj

def H2D(aLabel, aXnumber, aXmin, aXmax, aYnumber, aYmin, aYmax, aTree = memoryTree ):
 fac = aida.createHistogramFactory(aTree)
 obj = fac.create2D(aLabel,aXnumber,aXmin,aXmax,aYnumber,aYmin,aYmax)
 del_IHistogramFactory(fac)
 return obj

def H1D_get( aTree, aSID):
 object = aTree.find(aSID)
 if object == None :
  return H1D(aSID,aSID,10,0,1,aTree)
 else :
  return IManagedObject_to_IHistogram1D(object)

def H2D_get( aTree, aSID):
 object = aTree.find(aSID)
 if object == None :
  return H2D(aSID,aSID,10,0,1,10,0,1,aTree)
 else :
  return IManagedObject_to_IHistogram2D(object)

def H1D_add( aName, aLabel, aHisto1, aHisto2, aTree = memoryTree):
 fac = aida.createHistogramFactory(aTree)
 obj = fac.add(aName,aHisto1,aHisto2)
 obj.setLabel(aLabel)
 del_IHistogramFactory(fac)
 return obj

def H1D_sub( aName, aLabel, aHisto1, aHisto2, aTree = memoryTree):
 fac = aida.createHistogramFactory(aTree)
 obj = fac.sub(aName,aHisto1,aHisto2)
 obj.setLabel(aLabel)
 del_IHistogramFactory(fac)
 return obj

def H1D_div( aName, aLabel, aHisto1, aHisto2, aTree = memoryTree):
 fac = aida.createHistogramFactory(aTree)
 obj = fac.div(aName,aHisto1,aHisto2)
 obj.setLabel(aLabel)
 del_IHistogramFactory(fac)
 return obj

def H1D_mul( aName, aLabel, aHisto1, aHisto2, aTree = memoryTree):
 fac = aida.createHistogramFactory(aTree)
 obj = fac.mul(aName,aHisto1,aHisto2)
 obj.setLabel(aLabel)
 del_IHistogramFactory(fac)
 return obj

#///////////////////////////////////////////////////////
# Tuple procedures :
#///////////////////////////////////////////////////////

def Tuple( aName, aLabel, aColumnNames, aTree ):
 fac = aida.createTupleFactory(aTree)
 obj = fac.create(aName,aLabel,aColumnNames)
 del_ITupleFactory(fac)
 return obj

def Evaluator(aTuple,aScript):
 fac = aida.createEvaluatorFactory()
 obj = fac.createScripted(aTuple,aScript)
 del_IEvaluatorFactory(fac)
 return obj

def Filter(aTuple,aScript):
 fac = aida.createFilterFactory()
 obj = fac.createScripted(aTuple,aScript)
 del_IFilterFactory(fac)
 return obj

#///////////////////////////////////////////////////////
# Function procedures :
#///////////////////////////////////////////////////////
def Gaussian( aName, aLabel, aScale, aMean, aSigma, aTree = memoryTree):
 fac = aida.createFunctionFactory(aTree)
 params = std_vector_double()
 params.push_back(aScale)
 params.push_back(aMean)
 params.push_back(aSigma)
 obj = fac.create(aName,aLabel,"G",params,'')
 del_IFunctionFactory(fac)
 return obj

def BreitWigner( aName, aLabel, aHeight, aCenter, aWidth, aTree = memoryTree):
 fac = aida.createFunctionFactory(aTree)
 params = std_vector_double()
 params.push_back(aHeight)
 params.push_back(aCenter)
 params.push_back(aWidth)
 obj = fac.create(aName,aLabel,"BW",params,'')
 del_IFunctionFactory(fac)
 return obj

def Exponential( aName, aLabel, aA, aB, aTree = memoryTree):
 fac = aida.createFunctionFactory(aTree)
 params = std_vector_double()
 params.push_back(aA)
 params.push_back(aB)
 obj = fac.create(aName,aLabel,"E",params,'')
 del_IFunctionFactory(fac)
 return obj

def ScriptedFunction( aName, aLabel, aScript, aTree = memoryTree):
 fac = aida.createFunctionFactory(aTree)
 obj = fac.createScripted(aName,aLabel,aScript)
 del_IFunctionFactory(fac)
 return obj

def FitFunction( aName, aLabel, aType, aOptions, aTree = memoryTree):
 fac = aida.createFunctionFactory(aTree)
 obj = fac.createFit(aName,aLabel,aType,aOptions)
 del_IFunctionFactory(fac)
 return obj

#///////////////////////////////////////////////////////
# Plotter procedures :
#///////////////////////////////////////////////////////

def Plotter( aName = 'current' ):
 fac = aida.createPlotterFactory()
 obj = fac.create(aName)
 del_IPlotterFactory(fac)
 return obj

def Rep( aRegion, aObject ):
 representer = Lab_Representer(session)
 aRegion.addRepresentation(representer.represent(aObject))
 del representer
