#!/bin/sh -f
#set -x

#//////////////////////////////////////////////////////////
#// Used by Lib to produce dll for FORTRAN function.     //
#//////////////////////////////////////////////////////////


bin=
NAME=$1

#echo ${NAME}

if test -z $PLATFORMBIN ; then
 # Darwin : probably executed from a .app :
 lib_bin_dir="${LIBBINDIR}"
 lab_bin_dir="${LABBINDIR}"
else
 lib_bin_dir="${LIBROOT}/${PLATFORMBIN}"
 lab_bin_dir="${LABROOT}/${PLATFORMBIN}"
fi

/bin/rm -f ${bin}${NAME}.o

incs="-I${LIBROOT}/include -I${LABROOT}/include"
cc -c  ${incs} -o ${bin}${NAME}.o ${NAME}.c

if test `uname` = "Linux" ; then
/bin/rm -f ${bin}lib${NAME}.so
libs="${lab_bin_dir}/libLabHBOOK.so"
libs="${libs} ${lib_bin_dir}/libLibUtils.so"
g++ -shared -o ${bin}lib${NAME}.so ${bin}${NAME}.o ${libs}
fi

if test `uname` = "Darwin" ; then
/bin/rm -f ${bin}${NAME}.bundle
libs="${lab_bin_dir}/libLabHBOOK.dylib"
libs="${libs} ${lib_bin_dir}/libLibUtils.dylib"
c++ -bundle -twolevel_namespace -o ${bin}${NAME}.bundle ${bin}${NAME}.o ${libs}
fi

if test `uname` = "CYGWIN_NT-5.1" ; then
/bin/rm -f ${bin}${NAME}.dll
libs="${lab_bin_dir}/LabHBOOK.a"
libs="${libs} ${lib_bin_dir}/LibUtils.a"
g++ -shared -o ${bin}${NAME}.dll ${bin}${NAME}.o ${libs}
fi

if test `uname` = "OSF1" ; then
/bin/rm -f ${bin}lib${NAME}.so
libs="${lab_bin_dir}/libLabHBOOK.so"
libs="${libs} ${lib_bin_dir}/libLibUtils.so"
cxx -shared -o ${bin}lib${NAME}.so ${bin}${NAME}.o ${libs}
fi

/bin/rm -f ${bin}${NAME}.o
