#!/bin/sh -f
#set -x

#//////////////////////////////////////////////////////////
#// Used by Lib to produce dll for FORTRAN function.     //
#//////////////////////////////////////////////////////////


bin=
FNAME=$1
CNAME=$2

#echo ${FNAME}
#echo ${CNAME}

if test -z $PLATFORMBIN ; then
 # Darwin : probably executed from a .app :
 lib_bin_dir="${LIBBINDIR}"
 lab_bin_dir="${LABBINDIR}"
else
 lib_bin_dir="${LIBROOT}/${PLATFORMBIN}"
 lab_bin_dir="${LABROOT}/${PLATFORMBIN}"
fi

/bin/rm -f ${bin}${FNAME}.o
/bin/rm -f ${bin}${CNAME}.o

f77 -c -o ${bin}${FNAME}.o ${FNAME}.f

cc -c  -o ${bin}${CNAME}.o ${CNAME}.c

if test `uname` = "Linux" ; then
/bin/rm -f ${bin}lib${FNAME}.so
libs="${lab_bin_dir}/libLabHBOOK.so"
libs="${libs} ${lib_bin_dir}/libLibUtils.so"
g++ -shared -o ${bin}lib${FNAME}.so ${bin}${CNAME}.o ${bin}${FNAME}.o ${libs}
fi

if test `uname` = "Darwin" ; then
/bin/rm -f ${bin}${FNAME}.bundle
libs="${lab_bin_dir}/libLabHBOOK.dylib"
libs="${libs} ${lib_bin_dir}/libLibUtils.dylib"
c++ -bundle -twolevel_namespace -o ${bin}${FNAME}.bundle ${bin}${CNAME}.o ${bin}${FNAME}.o ${libs}
fi

if test `uname` = "CYGWIN_NT-5.1" ; then
/bin/rm -f ${bin}${FNAME}.dll
libs="${lab_bin_dir}/LabHBOOK.a"
libs="${libs} ${lib_bin_dir}/LibUtils.a"
g++ -shared -o ${bin}${FNAME}.dll ${bin}${CNAME}.o ${bin}${FNAME}.o ${libs}
fi

if test `uname` = "OSF1" ; then
/bin/rm -f ${bin}lib${FNAME}.so
libs="${lab_bin_dir}/libLabHBOOK.so"
libs="${libs} ${lib_bin_dir}/libLibUtils.so"
cxx -shared -o ${bin}lib${FNAME}.so ${bin}${CNAME}.o ${bin}${FNAME}.o ${libs}
fi

/bin/rm -f ${bin}${FNAME}.o
/bin/rm -f ${bin}${CNAME}.o
