#ifndef Lib_Arguments_h
#define Lib_Arguments_h

#include <vector>
#include <string>

namespace Lib {

class Arguments {
public:
  Arguments(int,char**);
  Arguments(const std::vector<std::string>&);
  Arguments(const std::string&);
  virtual ~Arguments();
  std::string tostring() const;
  std::vector<std::string> tovector() const;
  bool isAnArgument(const std::string&) const;
  unsigned int number() const;
  bool find(const std::string&,std::string&) const;
  bool match(const std::string&,std::string&,std::string&) const;
  bool add(const std::string&,const std::string&);
  int remove(const std::string&);
  bool first(std::string&,std::string&) const;
  bool last(std::string&,std::string&) const;
  bool knownOptions(const std::vector<std::string>&) const;
  void argcv(int&,char**&) const;
  const std::vector< std::pair<std::string,std::string> >& args() const;
private:
  void initialize(const std::vector<std::string>&);
  std::vector< std::pair<std::string,std::string> > fArgs;
};

}

#endif



