#ifndef Lib_BaseType_h
#define Lib_BaseType_h

#include <vector>

#include <Lib/Interfaces/IType.h>

#include <Lib/Property.h>

class IPrinter;

namespace Lib {

class BaseType : public virtual IType {
public: // IType :
  virtual void* cast(const std::string&) const;
  virtual std::vector<Property> properties();
  virtual Variable value(Identifier,const std::string&,void*);
  virtual IIterator* iterator();  
  virtual bool setName(const std::string&);
  virtual void setIterator(IIterator*);  
  virtual void destroy(Lib::Identifier,void*);
  virtual void set(Lib::Identifier,const std::string&,
                   const std::string&,void*);
  virtual void calculate(Lib::Identifier,const std::string&,
                         const std::vector<double>&,void*);
public:
  BaseType(IPrinter&);
  virtual ~BaseType();
  IPrinter& printer() const;
protected:
  void addProperty(const std::string&,Lib::Property::TYPE,int = 0,const std::string& = "");
  void clearProperties();
private:
  std::vector<Property> fList;
  IPrinter& fPrinter;
};

}

#endif



