#ifndef Lib_Columns_h
#define Lib_Columns_h 

class IPrinter;
#include <string>
#include <list>

#include <Lib/Variable.h>
#include <Lib/ColumnsLexer.h>

namespace Lib {

class Columns {
public:
  Columns(const std::string&,IPrinter&,int = 0);
  virtual ~Columns();
  Columns& operator=(const Columns&);
  void setScript(const std::string&);
  bool findVariables();
  std::list<Lib::Variable> result() const;
  void clear(); 
  const std::string& script() const;
  bool isSuccess() const;
public:  // Internal :
  const ColumnsLexer& lexer() const;
  IPrinter& printer() const;
public:
  static void deleteColumns(std::list<Lib::Variable>&);
  static void copyColumns(const std::list<Lib::Variable>&,std::list<Lib::Variable>&);
public:
  int fVerboseLevel;
  std::string fString;
  IPrinter& fPrinter;
  std::list<Variable> fStack;
  ColumnsLexer fLexer;
  bool fSuccess;
  Variable::eType fCurrentType;
  std::vector<Variable*> fTmpVars;
};

}

#endif
