#ifndef Lib_DLL_h
#define Lib_DLL_h

class IPrinter;
#include <string>

namespace Lib {

typedef void (*Procedure)();

class DLL {
public:
  DLL(const std::string&,IPrinter&,int = 0,bool = false);
  virtual ~DLL();
  bool open();
  Procedure findProcedure(const std::string&) const;
  void execute(const std::string&);
  const std::string& fileName() const;
  bool isOpened() const;
protected:
  void* fModule;
  IPrinter& fPrinter;
  std::string fName;
  std::string fDLL;
  int fVerboseLevel;
  std::string fError;
};

}

#endif




