#ifndef Lib_Element_h
#define Lib_Element_h 

#include <vector>
#include <string>

namespace Lib {

class Element {
public:
  Element(const std::string&,
           const std::vector<std::string>&,
           const std::string&);
  Element(const Element&);
  ~Element();
  const std::string& name() const;
  const std::vector<std::string>& attributes() const;
  const std::string& value() const;
  void setValue(const std::string&);
  bool attributeValue(const std::string&,std::string&) const;
  bool setAttributeValue(const std::string&,const std::string&);
private:
  std::string fName;
  std::vector<std::string> fAtts;
  std::string fValue;
};

}

#endif
