#ifndef Lib_FortranFormatLexer_h
#define Lib_FortranFormatLexer_h 

class IWriter;

#include <string>

namespace Lib {

// For FotranFormatToken.h :
class DataDescriptor;

class FortranFormatLexer {
public:
  FortranFormatLexer(IWriter&,int = 0);
private:
  FortranFormatLexer(const FortranFormatLexer&);
  FortranFormatLexer& operator=(const FortranFormatLexer&);
public:
  void set(const std::string&);
  IWriter& printer() const;
  int verboseLevel() const;
public:
  static int input(char*,int); // Can't be avoided.
private:
  int fVerboseLevel;
  std::string fString;
  char* fCurrent;
  char* fEnd;
  IWriter& fPrinter;
};

}

#endif
