#ifndef Lib_IFunction_h
#define Lib_IFunction_h

#include <string>
#include <vector>

namespace Lib {

class IFunction {
public:
  virtual ~IFunction() {};
public:
  virtual const std::string& file() const = 0;
  virtual const std::string& name() const = 0;
  virtual void* address() const = 0;
  virtual const std::string& signature() const = 0;
  virtual unsigned int dimension() const = 0;
  virtual double value(const std::vector<double>&) const = 0;
};

}

#endif
