#ifndef Lib_IManager_h
#define Lib_IManager_h

/**
 * Pure abstract interface for a named manager.
 * 
 * @author G.Barrand
 */

#include <string>

class IManager {
public:
  virtual ~IManager() {}
  virtual void* cast(const std::string&) const = 0;
public:
  /**
   * @return The name of the manager.
   */
  virtual const std::string& name() const = 0;
};

#endif
