#ifndef Lib_IReader_h
#define Lib_IReader_h

/**
 * @class IReader
 *
 *  IReader is the interface to handle a basic reader.
 *
 * @author Guy Barrand
 * @date 2003
 */

class IReader {
public:
  virtual ~IReader() {}

  /** Read the given buffer.
   * @param aBuffer : buffer to read into. 
   * @param aLength : length to read.
   * @param aReadLength : length read.
   * @return false in case of failure.
   */
  virtual bool read(void* aBuffer,unsigned int aLength,int& aReadLength) = 0;

  /** To enable / disable the printer. */
  virtual void disable() = 0;
  virtual void enable() = 0;
  virtual bool enabled() const = 0;
};

#endif




