#ifndef Lib_IRelationManager_h
#define Lib_IRelationManager_h

namespace Lib {

class IRelation;
class IMessage;

class IRelationVisitor {
public:
  virtual ~IRelationVisitor() {};
public:
  virtual bool visit(IRelation&) = 0;
};

class IRelationManager {
public:
  virtual ~IRelationManager() {};
public:
  virtual void add(IRelation*) = 0;
  virtual void visit(IRelationVisitor&) = 0;
  virtual void remove(IRelationVisitor&) = 0;

  virtual void removeWith(void*) = 0;
};

}

#endif
