#ifndef Lib_IType_h
#define Lib_IType_h

#include <string>
#include <vector>

namespace Lib {

typedef void* Identifier;

class Property;
class Variable;
class IIterator;

class IType {
public:
  virtual ~IType() {}
  virtual void* cast(const std::string&) const = 0;
public:
  virtual const std::string& name() const = 0;
  virtual std::vector<Property> properties() = 0;
  virtual IIterator* iterator() = 0;  
  virtual Variable value(Identifier,const std::string&,void*) = 0;
  virtual bool setName(const std::string&) = 0;
  virtual void setIterator(IIterator*) = 0;  
  // Default actions :
  virtual void destroy(Identifier,void*) = 0 ;
  virtual void set(Identifier,const std::string&,
                   const std::string&,void*) = 0 ;
  virtual void calculate(Identifier,const std::string&,
                         const std::vector<double>&,void*) = 0;
};

}

#endif
