#ifndef Lib_ITypeManager_h
#define Lib_ITypeManager_h

#include <string>
#include <vector>
#include <list>

#include <Lib/Interfaces/IType.h> // For Identifier.

class IPrinter;

namespace Lib {

class IType;
class IAction;
class Handler;

class ITypeManager {
public:
  virtual ~ITypeManager() {}
public:
  virtual void addType(IType*) = 0;
  virtual void removeType(const std::string&) = 0;
  virtual void addAction(IAction*) = 0;
  virtual void eraseHandlers() = 0;
  virtual IType* findType(const std::string&) = 0;
  virtual IPrinter& printer() const = 0;
  virtual void addHandler(IType&,Identifier,void*) = 0;
  virtual std::list<Lib::Handler>& handlers() = 0;
  virtual std::list<Lib::IType*> handlersTypes() = 0;
  virtual std::string execute(const std::string&,
                              const std::vector<std::string>&) = 0;
  virtual std::vector<std::string> typeNames() const = 0;
  virtual const std::list<Lib::IType*>& types() const = 0;
  virtual void setVerboseLevel(int) = 0;
  virtual int verboseLevel() const = 0;
};

}

#endif



