#ifndef Lib_Manager_h
#define Lib_Manager_h

#include <Lib/Interfaces/ISession.h>
#include <Lib/Interfaces/IManager.h>
#include <Lib/Interfaces/IPrinter.h>

namespace Lib {

template <class aT> 
aT* findManager(
 ISession& aSession
,const std::string& aName
,const std::string& aCast
) 
{
  IManager* manager = aSession.findManager(aName);
  if(!manager) return 0;
  if(aCast.find("*")!=std::string::npos) {
    IPrinter& printer = aSession.printer();
    printer.write(std::string("Lib::findManager : \"")+aName+"\" bad format for \""+aCast+"\".\n");
  }
  //return (aT*)(manager->cast(aCast));
  aT* mgr = (aT*)(manager->cast(aCast));
  if(!mgr) {
    IPrinter& printer = aSession.printer();
    printer.write(std::string("Lib::findManager : \"")+aName+"\" cast to  \""+aCast+"\" failed.\n");
  }
  return mgr;
}

}


#define Lib_findManager(aSession,aName,aClass) Lib::findManager<aClass>(aSession,aName,#aClass)

#endif
