#ifndef Lib_Property_h
#define Lib_Property_h

#include <string>

namespace Lib {

class Property {
public:
  enum TYPE { // If "Type" there is a clash in cint with the class "Type".
    NONE = 0,
    INTEGER = 1,
    DOUBLE = 2,
    STRING = 3,
    POINTER = 4,
    BOOLEAN = 5
  };
  Property();
  Property(const Property&);
  Property(const std::string&,TYPE,int = 0,const std::string& = "");
  Property& operator =(const Property&);
  virtual ~Property();
  void set(const std::string&,TYPE,int = 0,const std::string& = "");
  const std::string& name() const;
  const std::string& label() const;
  const std::string& header() const;
  void dress(std::string&);
private:
  std::string fName;
  TYPE fType;
  int fLength;
  std::string fLabel;
  std::string fHeader;
};

}

#endif



