#ifndef Lib_RandomFromFunction_h
#define Lib_RandomFromFunction_h

class IPrinter;

namespace Lib {

class IFunction;
class RandomFlat;

class RandomFromFunction {
public:
  RandomFromFunction(IFunction&,int,double,double,IPrinter&);
  virtual ~RandomFromFunction();
  double shoot();
  bool isValid() const;
  bool reset(int);
  double integrate(double,double,double = 0.000001) const;
private:
  void clear();
private:
  IFunction& fFunction;
  IPrinter& fPrinter;
  int fNpx;
  double fXmin;
  double fXmax;
  double* fIntegral;
  double* fAlpha;
  double* fBeta;
  double* fGamma;
  RandomFlat* fRandomFlat;
};

}

#endif
