#ifndef Lib_RelationManager_h
#define Lib_RelationManager_h

// Inheritance :
#include <Lib/Interfaces/IRelation.h>
#include <Lib/Interfaces/IManager.h>
#include <Lib/Interfaces/IRelationManager.h>

#include <list>

class ISession;

namespace Lib {

class RelationManager
:public virtual IManager 
,public virtual IRelationManager 
{
public: //IManager
  virtual const std::string& name() const;
  virtual void* cast(const std::string&) const;
public: //IRelationManager
  virtual void add(IRelation*);
  virtual void visit(IRelationVisitor&);
  virtual void remove(IRelationVisitor&);
  virtual void removeWith(void*);
public:
  RelationManager(ISession&);
  virtual ~RelationManager();
private:
  ISession& fSession;
  std::string fName;
  std::list<IRelation*> fList;
};

}

#endif




