#ifndef Lib_Session_h
#define Lib_Session_h

#include <Lib/Interfaces/ISession.h>

#include <list>

namespace Lib {

class Session : public virtual ISession {
public: //ISession
  virtual void addManager(IManager*);
  virtual void removeManager(IManager*);
  virtual IManager* findManager(const std::string&) const;
  virtual void destroyManager(const std::string&);
  virtual IPrinter& printer() const;
  virtual bool load(const std::string&,const std::string&);
  virtual void redirectOutput(bool);
  virtual bool setParameter(const std::string&,const std::string&);
  virtual bool parameterValue(const std::string&,std::string&);
  virtual std::vector<std::string> availableParameters() const;
  virtual void flush();
  virtual void setVerboseLevel(int);
  virtual int verboseLevel() const;
  virtual std::vector<std::string> managerNames(const std::string&) const;
public:
  Session(IPrinter&);
  virtual ~Session();
private:
  std::list<IManager*> fManagers;
  IPrinter& fPrinter;
  int fVerboseLevel;
};

}

#endif
