#ifndef Lib_dirmanip_h
#define Lib_dirmanip_h

#include <string>
#include <vector>
#include <Lib/Interfaces/IDirectoryVisitor.h>

namespace Lib {

class Directory {
public:
  Directory();
  Directory(const Directory&);
  virtual ~Directory();
public:
  bool visit(IDirectoryVisitor&);
  void addDirectory(Directory&);
  void addFile(const std::string&);
  void setPath(const std::string&);
  const std::string& path() const;
  std::vector<Directory>& directories();
private:
  std::string fPath;
  std::vector<Directory> fDirs;
  std::vector<std::string> fFiles;
};

class dirmanip {
public:
  static bool create(const std::string&);
  static bool remove(const std::string&);
  static bool removeInDirectory(const std::string&,const std::string&);
  static bool entries(const std::string&,std::vector<std::string>&,bool = true);
  static bool directory(std::string&);
  static bool go(const std::string&);
  static bool isDirectory(const std::string&,bool&);
  static bool isDot(const std::string&);
  static bool content(Directory&,const std::string& = "");
  static bool isAnEntry(const std::string&,const std::string&);
  static bool mkcd(const std::string&);
  static bool mkcd(const std::vector<std::string>&);
  static std::string home();
  static bool goHome();
  static bool goRoot();
};

}

#endif
