#ifndef OnX_BaseCyclic_h
#define OnX_BaseCyclic_h 

#include <OnX/Interfaces/ICyclic.h>

class ISession;
class IScriptManager;

namespace OnX {

class BaseCyclic : public virtual ICyclic {
public: //ICyclic
  virtual const std::string& name() const;
  virtual void setDelay(int);
  virtual void setScript(const std::string&,const std::string&);
  virtual void execute();
  virtual int delay() const;
  virtual int iterations() const;
public:
  BaseCyclic(ISession&,const std::string&,
             int,const std::string&,const std::string&);
  virtual ~BaseCyclic();
protected:
  ISession& fSession;
  std::string fName;
  int fDelay;
  std::string fInterpreter;
  std::string fScript;
  IScriptManager* fScriptManager;
  int fCounter;
};

}

#endif

