#ifndef OnX_OnX_h
#define OnX_OnX_h

#include <string>

class IUI;
class ISession;

namespace OnX {

class OnX {
public:
  OnX(int = 0);
  virtual ~OnX();
public:
  /* @param aFile GUI .onx file to load.
   * @param aDriver GUI to load with.
   * @param aShow Show the GUI.
   * @param aThread Start the GUI in a thread
   * @return The OnX GUI. 
   */
  virtual IUI* createUI(const std::string& aFile = "",
                        const std::string& aDriver = "",
                        bool aShow = true,
                        bool aThread = false);

  /*
   * @return The session.
   */
  virtual ISession* session() const;
private:
  ISession* fSession;
  IUI* fUI;
  int fArgc;
  char** fArgv;
};

}

#endif


