#ifndef OnX_StyleManager_h
#define OnX_StyleManager_h

// Inheritance :
#include <Lib/Interfaces/IManager.h>
#include <OnX/Interfaces/IStyleManager.h>

#include <vector>

class ISession;

namespace OnX {

class StyleManager : public virtual IManager, public virtual IStyleManager {
public: //IManager
  virtual const std::string& name() const;
  virtual void* cast(const std::string&) const;
public: //IStyleManager
  virtual bool findStyle(const std::string&,std::string&);
  virtual bool loadFile(const std::string&);
  virtual std::vector<std::string> styles() const;
public:
  StyleManager(ISession&);
  virtual ~StyleManager();
private:
  ISession& fSession;
  std::string fName;
  std::vector< std::pair<std::string,std::string> > fList;
};

}

#endif
