#ifndef OnX_Widget_h
#define OnX_Widget_h 

// Inheritance :
#include <OnX/Interfaces/IWidget.h>
#include <Lib/ItemML.h>

class IPrinter;
class IWidgetClass;

namespace OnX {

class Widget : public virtual IWidget, public Lib::ItemML {
public: //IWidget
  virtual void* cast(const std::string& aTo) const;
  virtual IWidgetClass& widgetClass() const;
  virtual std::string name() const;
  virtual void* nativeWidget() const;
public:
  Widget(Lib::ItemMLFactory&,Lib::ItemML*,IWidgetClass&);
  virtual ~Widget();
private:
  IWidgetClass& fWidgetClass;
};

class WidgetFactory : public Lib::ItemMLFactory {
public:
  WidgetFactory(IPrinter&,const std::vector<IWidgetClass*>&);
  virtual ~WidgetFactory();
public:
  virtual Lib::ItemML* create(const std::string&,Lib::ItemML*);
private:
  IWidgetClass* findWidgetClass(const std::string&) const;
private:
  IPrinter& fPrinter;
  const std::vector<IWidgetClass*>& fWidgetClasses;
};

}

#endif
