#ifndef OnX_IIB_h
#define OnX_IIB_h

#include <string>
#include <vector>

class IWidgetClass;

namespace Lib {
  class ItemML; //Not an interface !
}

class IIB {
public:
  virtual ~IIB() {};
public:
  virtual std::string tree() const = 0;
  virtual bool loadReferenceFile(Lib::ItemML&, const std::string&) = 0;
  virtual Lib::ItemML* topItemML() const = 0;
  virtual IWidgetClass* findWidgetClass(const std::string&) const = 0;
  virtual std::vector< std::pair<bool,std::string> > parseDecorations(const std::string&) const =0;
  virtual const std::vector<std::string>& callbackLanguageList() const = 0;
  virtual bool propertyType(const std::string&,std::string&) const = 0;
  virtual std::string createWidgetName() = 0;
};

#endif
