#ifndef OnX_IScriptManager_h
#define OnX_IScriptManager_h

#include <string>

typedef void (*IInterpreterFunction)(const std::string&,void*);

class IScriptManager {
public:
  virtual ~IScriptManager() {};
public:
  virtual void addInterpreter(const std::string&,
                              const std::string&,
                              const std::string&) = 0;
  virtual void setInterpreterFunction(const std::string&,
                                      IInterpreterFunction,
                                      void*) = 0;
  virtual bool findInterpreterFunction(const std::string&,
                                       IInterpreterFunction&,
                                       void*&) = 0;
  virtual void executeFile(const std::string&,const std::string&) = 0;
  virtual void executeScript(const std::string&,const std::string&) = 0;
  virtual void recordExecutedScripts(bool) = 0;
  virtual bool isOperational(const std::string&) = 0;
};

#endif
