#ifndef OnX_QPageViewer_h
#define OnX_QPageViewer_h 

// Inheritance :
#include <qwidget.h>

#include <OnX/Inventor/GuiPageViewer.h>
#include <Inventor/Qt/viewers/SoQtExaminerViewer.h>

#include <string>

class QPopupMenu;
class QPainter;
class QPoint;
class QCallbackData;

namespace OnX {

class QPageViewer : public QWidget {
  Q_OBJECT
public:
  QPageViewer(QWidget* = 0,const char* = 0);
  virtual ~QPageViewer();
  bool setParameter(const std::string&,const std::string&);
  bool write(const std::string&,const std::string&);
  SoPage* page() const;
  void emitCollect(const std::string&);
  void emitPopup(const std::string&);
  void addPopupEntry(const std::string&);
signals:
  void collect(QCallbackData&);
  void popup(QCallbackData&);
private:
  static SbBool eventCB(void*,QEvent*);
  void drawRect(QPainter&,const QPoint&,const QPoint&);
  void getRectangle(int,int,int,int,int&,int&,int&,int&);
private:
  GuiPageViewer<QWidget*,SoQtExaminerViewer,QEvent>* fViewer;
  QPopupMenu* fPopupMenu;
  bool fRubberMove;
  QPoint fBeginMove,fEndMove;
  int fPopX,fPopY;
};

class QPageViewerPopupCallback : public QObject {
  Q_OBJECT
public:
  QPageViewerPopupCallback(QPageViewer&,const std::string&);
public slots:
  void execute();
private:
  QPageViewer& fPageViewer;
  std::string fLabel;
};

}

#endif

