#ifndef OnX_QtTools_h
#define OnX_QtTools_h 

#include <string>
#include <vector>

class QString;
class IPrinter;
class QWidget;
class QHBox;
class QVBox;
class QListViewItem;
class QButton;
class QComboBox;
class QDialog;

#include <qnamespace.h>

class QCallbackData {
public:
  QCallbackData():x(0),y(0){}
public:
  std::string value;
  std::string event;
  int x;
  int y;  
};

namespace OnX {

std::string q2std(const QString&);
Qt::WFlags decorationFlags(const std::vector< std::pair<bool,std::string> >&,
                           IPrinter&);
int QWidgetGetNumberOfChildren(QWidget&);
void QWidgetSetForeground(QWidget&,const std::string&);
void QWidgetSetBackground(QWidget&,const std::string&);
void QButtonSetBackground(QButton&,const std::string&);
void QComboBoxSetBackground(QComboBox&,const std::string&);

bool QHBoxSetExpand(QHBox&,const std::string&);
bool QVBoxSetExpand(QVBox&,const std::string&);
std::string QListViewItemGetXML(QListViewItem*);

void QDialogDisableEnter(QDialog&);

}

#endif

