#
# To start OnX from a Python shell prompt :
#   OS> python2 -i OnX_start.py
# or :
#   OS> python2
#   >>> import OnX_start
#
# On Darwin, so that a native GUI works properly, someone has to start with :
#   Darwin> /usr/bin/pythonw -i OnX_start.py
# or :
#   Darwin> /usr/bin/pythonw
#   >>> import OnX_start
#
# When under the GUI, a OnX/Python> ui.exit() or a OnX/File/Exit
# gives control back to the python shell.
# Then a :
#   >>> OnX_start.ui.steer()
# gives control again to the GUI.
#
# To quit properly from the python shell prompt :
#   >>> del OnX_start.onx
#   >>> <CTRL-D>
#

def start(thrd = 0):
 global onx,ui
 from OnX_SWIG import OnX_OnX
 onx = OnX_OnX(0)

 from OnX_SWIG import IManager_to_IScriptManager
 scriptManager = IManager_to_IScriptManager(onx.session().findManager('ScriptManager'))
 #FIXME : restore Python from GUI in case of thread.
 if thrd == 0:
   scriptManager.executeScript('Python',' ');

 ui = onx.createUI('','')
 #ui = onx.createUI('','Xt')
 #ui = onx.createUI('','Gtk')
 # Qt started in a thread (1 for last argument) :
 #ui = onx.createUI('','Qt',1,1)
 #ui = onx.createUI('$ONXROOT/scripts/OnX/OnX.onx','Qt',1,1)
 # If started in a thread, the below ui.steer() have to be commented.

 if thrd == 1:
   import time
   while 1:
     ui.synchronize()
     time.sleep( 0.01 )
 else :
   ui.steer()

 print 'To give control to the GUI again :'
 print '  >>> OnX_start.ui.steer()'
 print 'To delete the OnX object (and then the GUI) :'
 print '  >>> del OnX_start.onx'


#FIXME : 
#import thread
#thread.start_new_thread( start, (1,) )

start()
